/*
 *  parameters.h
 *  Astronomy
 *
 *  Created by Travis Desell on 2/21/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */
 
#ifndef ASTRONOMY_PARAMETERS_H
#define ASTRONOMY_PARAMETERS_H

#include <stdio.h>
#include <stdlib.h>

int		get_number_streams();
int		get_number_stream_parameters();

double		get_background_weight();
double*		get_background_parameters();
double*		get_stream_weights();
double**	get_stream_parameters();

void		get_parameters_as_double_array(double** parameters, int *parameter_length);
void		set_parameters_from_double_array(double* parameters);
void		get_step_sizes_as_double_array(double** parameters, int *parameter_length);

void print_double_array(FILE *file, char *array_name, int size, double *array_t);
void print_boolean(FILE *file, bool value);
void print_boolean_array(FILE *file, char *array_name, int size, bool *array_t);
void print_parameters(FILE *file);

void read_double_array(FILE *file, char *array_name, int size, double** array_t);
void read_boolean(FILE *file, bool *value);
void read_boolean_array(FILE *file, char *array_name, int size, bool **array_t);
void read_parameters();
void parameter_dump();

#endif
