#include <cstdio>

#ifndef H_BOINC_GENETIC_POPULATION
#define H_BOINC_GENETIC_POPULATION

typedef struct population {     
	char *name;

	int update_rate;
	int inserts_since_update;

	int evaluations_done;
	int max_evaluations_allowed;

	int max_population_size;
	double reproduction_chance;
	int double_shot;

	int current_population_size;
	int parameter_length;

	int unsent_workunit_buffer;

	double *parameter_min;
	double *parameter_max;
	double *fitness;
	double **parameters;
} POPULATION;

void		print_statistics(FILE* file, POPULATION population);
void		read_population(FILE* file, POPULATION *population);
void		write_population(FILE* file, POPULATION population);

double*		generate_random_parameters(POPULATION population);
double*		generate_mutation(POPULATION population);
double*		generate_reproduction(POPULATION population);
double**	generate_double_shot(POPULATION population);

void		insert_member(POPULATION *population, double* parameters, double fitness);

#endif
