/*
 *  gradient_descent.h
 *	This is the API for the different gradient descent methods.
 */
 
#ifndef GRADIENT_DESCENT_H
#define GRADIENT_DESCENT_H

/*
 *	The following perform a gradient descent from the initial parameteres using the
 *	specified step sizes.
 */
double* gradient_descent(double* initial_parameters, double* step_sizes, int parameter_length);
double* conjugate_gradient_descent(double* initial_parameters, double* step_sizes, int parameter_length);
double* hessian_conjugate_gradient_descent(double* initial_parameters, double* step_sizes, int parameter_length);

#endif
