#ifndef MATRIX_H
#define MATRIX_H

#include <stdio.h>
#include <stdlib.h>

typedef struct matrix {
        int x,y;
        double **values;
} MATRIX;

MATRIX create_matrix(int x, int y);
MATRIX matrix_mul(MATRIX m1, MATRIX m2);
MATRIX matrix_add(MATRIX m1, MATRIX m2);
MATRIX matrix_sub(MATRIX m1, MATRIX m2);
MATRIX matrix_rdiv(MATRIX m1, MATRIX m2);
MATRIX invert(MATRIX m);
MATRIX matrix_neg(MATRIX m);

MATRIX matrix_apply_mul(MATRIX m, double d);
MATRIX matrix_apply_sub(MATRIX m, double d);
MATRIX matrix_apply_add(MATRIX m, double d);
MATRIX matrix_apply_div(MATRIX m, double d);

double matrix_norm(MATRIX m);
double mean(MATRIX m);
double* matrix2array(MATRIX m);

void print_matrix(MATRIX m);

#endif
