/*
 *  simplex.h
 *	This is the API for the Neader-Mead Downhill Simplex Method.
 */
 
#ifndef SIMPLEX_H
#define SIMPLEX_H

/*
 *      The following sets the maximum number of iterations to perform.
 */
void simplex__max_iterations(int max_iterations);
  
/*
 *	The following perform a simplex starting from the initial parameter set, number_parameters is the
 *	total number of parameter sets, and parameter_length is the number of parameters in each set.
 */
double* simplex(double** initial_parameters, int number_parameters, int parameter_length);

#endif
