package gmle.salsa.astronomy;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.LiteActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import gmle.salsa.framework.IntegralEvaluator;
import gmle.salsa.framework.IntegralEvaluatorState;
import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileReader;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.Vector;

public class AstronomyEvaluatorState extends LiteActorState implements IntegralEvaluatorState {
	public AstronomyEvaluatorState(UAN uan) {
		super(uan);
		self = new AstronomyEvaluator(getUAN());
	}

	public AstronomyEvaluatorState(UAL ual) {
		super(ual);
		self = new AstronomyEvaluator(getUAL());
	}

	public AstronomyEvaluatorState(String identifier) {
		super(identifier);
		self = new AstronomyEvaluator(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		}  else if (methodName.equals("initialize") && arguments.length == 3 && (arguments[0] == null || arguments[0] instanceof Object[]) && (arguments[1] == null || arguments[1] instanceof Integer) && (arguments[2] == null || arguments[2] instanceof Integer)) {
			initialize((Object[])arguments[0], ((Integer)arguments[1]).intValue(), ((Integer)arguments[2]).intValue());
			return null;
		}  else if (methodName.equals("compose_integral") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof double[][])) {
			return compose_integral((double[][])arguments[0]);
		}  else if (methodName.equals("evaluate") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof double[])) {
			return new Double(evaluate((double[])arguments[0]));
		}  else if (methodName.equals("evaluate_integral_slice") && arguments.length == 3 && (arguments[0] == null || arguments[0] instanceof double[]) && (arguments[1] == null || arguments[1] instanceof Integer) && (arguments[2] == null || arguments[2] instanceof Integer)) {
			return evaluate_integral_slice((double[])arguments[0], ((Integer)arguments[1]).intValue(), ((Integer)arguments[2]).intValue());
		}  else if (methodName.equals("integral_function") && arguments.length == 0) {
			return integral_function();
		}  else if (methodName.equals("compose_likelihood") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof double[][])) {
			return new Double(compose_likelihood((double[][])arguments[0]));
		}  else if (methodName.equals("evaluate_likelihood_slice") && arguments.length == 4 && (arguments[0] == null || arguments[0] instanceof double[]) && (arguments[1] == null || arguments[1] instanceof double[]) && (arguments[2] == null || arguments[2] instanceof Integer) && (arguments[3] == null || arguments[3] instanceof Integer)) {
			return evaluate_likelihood_slice((double[])arguments[0], (double[])arguments[1], ((Integer)arguments[2]).intValue(), ((Integer)arguments[3]).intValue());
		}  else if (methodName.equals("set_integrals") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof double[])) {
			set_integrals((double[])arguments[0]);
			return null;
		}  else if (methodName.equals("likelihood_function") && arguments.length == 0) {
			return likelihood_function();
		}  else if (methodName.equals("separation_function") && arguments.length == 0) {
			separation_function();
			return null;
		}  else if (methodName.equals("get_transform") && arguments.length == 3 && (arguments[0] == null || arguments[0] instanceof double[]) && (arguments[1] == null || arguments[1] instanceof double[]) && (arguments[2] == null || arguments[2] instanceof double[][])) {
			get_transform((double[])arguments[0], (double[])arguments[1], (double[][])arguments[2]);
			return null;
		}  else if (methodName.equals("do_transform") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof double[]) && (arguments[1] == null || arguments[1] instanceof double[][])) {
			do_transform((double[])arguments[0], (double[][])arguments[1]);
			return null;
		}  else if (methodName.equals("transform_point") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof double[]) && (arguments[1] == null || arguments[1] instanceof double[][])) {
			return transform_point((double[])arguments[0], (double[][])arguments[1]);
		}  else if (methodName.equals("make_test_data") && arguments.length == 0) {
			make_test_data();
			return null;
		}  else if (methodName.equals("readVolumeFromFile") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String)) {
			readVolumeFromFile((String)arguments[0]);
			return null;
		}  else if (methodName.equals("read_integer") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof String) && (arguments[1] == null || arguments[1] instanceof BufferedReader)) {
			return new Integer(read_integer((String)arguments[0], (BufferedReader)arguments[1]));
		}  else if (methodName.equals("readStarsFromFile") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String)) {
			readStarsFromFile((String)arguments[0]);
			return null;
		}  else if (methodName.equals("set_parameters") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof double[])) {
			set_parameters((double[])arguments[0]);
			return null;
		}  else if (methodName.equals("convertToConstrained") && arguments.length == 0) {
			convertToConstrained();
			return null;
		}  else if (methodName.equals("convertToUnconstrained") && arguments.length == 0) {
			convertToUnconstrained();
			return null;
		}  else if (methodName.equals("readParametersFromFile") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String)) {
			readParametersFromFile((String)arguments[0]);
			return null;
		}  else if (methodName.equals("readArray") && arguments.length == 3 && (arguments[0] == null || arguments[0] instanceof String) && (arguments[1] == null || arguments[1] instanceof String) && (arguments[2] == null || arguments[2] instanceof Integer)) {
			return readArray((String)arguments[0], (String)arguments[1], ((Integer)arguments[2]).intValue());
		}  else if (methodName.equals("readBooleanArray") && arguments.length == 3 && (arguments[0] == null || arguments[0] instanceof String) && (arguments[1] == null || arguments[1] instanceof String) && (arguments[2] == null || arguments[2] instanceof Integer)) {
			return readBooleanArray((String)arguments[0], (String)arguments[1], ((Integer)arguments[2]).intValue());
		}  else if (methodName.equals("printParameters") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof OutputStream)) {
			printParameters((OutputStream)arguments[0]);
			return null;
		}  else if (methodName.equals("writeArray") && arguments.length == 3 && (arguments[0] == null || arguments[0] instanceof String) && (arguments[1] == null || arguments[1] instanceof double[]) && (arguments[2] == null || arguments[2] instanceof DataOutputStream)) {
			writeArray((String)arguments[0], (double[])arguments[1], (DataOutputStream)arguments[2]);
			return null;
		}  else if (methodName.equals("writeArray") && arguments.length == 3 && (arguments[0] == null || arguments[0] instanceof String) && (arguments[1] == null || arguments[1] instanceof boolean[]) && (arguments[2] == null || arguments[2] instanceof DataOutputStream)) {
			writeArray((String)arguments[0], (boolean[])arguments[1], (DataOutputStream)arguments[2]);
			return null;
		}  else if (methodName.equals("printParameters") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String)) {
			printParameters((String)arguments[0]);
			return null;
		}  else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	boolean[] background_optimize_parameter;
	boolean[] stream_weight_optimize;
	boolean[][] stream_optimize_parameter;
	double[] background_h;
	double[] stream_weight_h;
	double[][] stream_h;
	double[] background_mutation_range;
	double[] background_parameter_min;
	double[] background_parameter_max;
	double[] stream_weight_mutation_range;
	double[] stream_weight_min;
	double[] stream_weight_max;
	double[][] stream_mutation_range;
	double[][] stream_parameter_min;
	double[][] stream_parameter_max;
	int convolve;
	double background_weight;
	double[] background_parameters;
	double[] stream_weights;
	double[][] stream_parameters;
	double[] xsun = { -8.5, 0.0, 0.0 };
	double deg = Coordinates.deg();
	int wedge;
	double background_integral;
	double stream_integral;
	double[] stream_integrals;
	double nu_min, nu_max, nu_step;
	int nu_steps;
	double mu_min, mu_max, mu_step;
	int mu_steps;
	double r_min, r_max, r_step;
	int r_steps;
	int max_points;
	double[][] star_points;
	double likelihood;
	int num_zero;
	int bad_jacobians;
	int rank;
	int max_rank;
	String star_file;
	String volume_file;
	String parameter_file;
	public void construct(){
	}
	public void initialize(Object[] init_params, int rank, int max_rank) {
		this.star_file = (String)init_params[0];
		this.volume_file = (String)init_params[1];
		this.parameter_file = (String)init_params[2];
		this.rank = rank;
		this.max_rank = max_rank;
		this.readStarsFromFile(star_file);
		this.readVolumeFromFile(volume_file);
		this.readParametersFromFile(parameter_file);
	}
	public double[] compose_integral(double[][] integral_results) {
		double background_integral = 0.0;
		double stream_integral = 0.0;
		double num_calls = 0.0;
		for (int i = 0; i<integral_results.length; i++){
			background_integral += integral_results[i][0];
			stream_integral += integral_results[i][1];
			num_calls += integral_results[i][2];
		}
		System.err.println("background_integral: "+background_integral+", stream_integral: "+stream_integral+", num_calls: "+num_calls);
		return new double[]{ background_integral, stream_integral };
	}
	public double evaluate(double[] parameters) {
		this.set_parameters(parameters);
		this.integral_function();
		this.likelihood_function();
		likelihood /= star_points.length;
		likelihood *= -1.0;
		return likelihood;
	}
	public double[] evaluate_integral_slice(double[] parameters, int rank, int max_rank) {
		this.set_parameters(parameters);
		double[] result = this.integral_function();
		return result;
	}
	public double[] integral_function() {
		background_integral = 0.0;
		stream_integral = 0.0;
		double[] current_point = { 0.0, 0.0, 0.0 };
		double[] integral_point = { 0.0, 0.0, 0.0 };
		double[] xyz = new double[3];
		double r, next_r;
		double ir, id;
		int num_calls = 0;
		double total_volume = 0.0;
		double V = 0.0;
		for (int i = 0; i<mu_steps; i++){
			double mu = mu_min+(i*mu_step);
			for (int j = 0; j<nu_steps; j++){
				double nu = nu_min+(j*nu_step);
				for (int k = 0; k<r_steps; k++){
					double log_r = r_min+(k*r_step);
					r = Math.pow(10.0, (log_r-14.2)/5.0);
					next_r = Math.pow(10.0, (log_r+r_step-14.2)/5.0);
					if (wedge>0) {
						ir = (Math.pow(next_r, 3.0)-Math.pow(r, 3.0))/3.0;
						id = Math.cos((90-nu-nu_step)/deg)-Math.cos((90-nu)/deg);
						V = ir*id*mu_step/deg;
						double[] ra = { 0.0 };
						double[] dec = { 0.0 };
						double[] point0 = { 0.0 };
						double[] point1 = { 0.0 };
						ATSurveyGeometry.atGCToEq(mu+0.5*mu_step, nu+0.5*nu_step, ra, dec, Coordinates.get_node(), Coordinates.wedge_incl(wedge));
						ATSurveyGeometry.atEqToGal(ra[0], dec[0], point0, point1);
						integral_point[0] = point0[0];
						integral_point[1] = point1[0];
						integral_point[2] = (next_r+r)/2.0;
						total_volume += V;
					}
					else {
						V = mu_step*nu_step*r_step;
						xyz[0] = mu+0.5*mu_step;
						xyz[1] = nu+0.5*nu_step;
						xyz[2] = r+0.5*r_step;
						integral_point = Coordinates.xyz2lbr(xyz);
					}
					double bg_prob = 0.0;
					double st_prob = 0.0;
					if (convolve!=0) {
						bg_prob = Probability.stPbxConvolved(integral_point, background_parameters, convolve);
						st_prob = Probability.stPsgConvolved(integral_point, stream_parameters[0], wedge, convolve);
					}
					else {
						bg_prob = Probability.stPbx(integral_point, background_parameters);
						st_prob = Probability.stPsg(integral_point, stream_parameters[0], wedge);
					}
					background_integral += bg_prob*V;
					stream_integral += st_prob*V;
					num_calls++;
				}
			}
		}
		stream_integrals[0] = stream_integral;
		return new double[]{ background_integral, stream_integral, num_calls };
	}
	public double compose_likelihood(double[][] likelihood_results) {
		double likelihood = 0.0;
		double num_zero = 0.0;
		double bad_jacobians = 0.0;
		double total_stars = 0.0;
		for (int i = 0; i<likelihood_results.length; i++){
			likelihood += likelihood_results[i][0];
			num_zero += likelihood_results[i][1];
			bad_jacobians += likelihood_results[i][2];
			total_stars += likelihood_results[i][3];
		}
		likelihood /= total_stars;
		likelihood *= -1.0;
		System.err.println("Evaluated likelihood: "+likelihood+", num_zero: "+num_zero+", bad_jacobians: "+bad_jacobians+", total_stars: "+total_stars);
		return likelihood;
	}
	public double[] evaluate_likelihood_slice(double[] parameters, double[] integrals, int rank, int max_rank) {
		this.set_parameters(parameters);
		this.set_integrals(integrals);
		double[] result = this.likelihood_function();
		return result;
	}
	public void set_integrals(double[] integrals) {
		background_integral = integrals[0];
		stream_integral = integrals[1];
		stream_integrals[0] = integrals[1];
	}
	public double[] likelihood_function() {
		likelihood = 0;
		num_zero = 0;
		bad_jacobians = 0;
		double exp_background_weight = Math.exp(background_weight);
		double sum_exp_weights = 0.0;
		double[] exp_stream_weights = new double[stream_weights.length];
		for (int i = 0; i<stream_weights.length; i++){
			exp_stream_weights[i] = Math.exp(stream_weights[i]);
			sum_exp_weights += exp_stream_weights[i];
		}
		sum_exp_weights += exp_background_weight;
		for (int current = 0; current<max_points; current++){
			double star_prob = 0.0;
			double[] star_coords = star_points[current];
			double sum_integrals = 0.0;
			for (int i = 0; i<stream_parameters.length; i++){
				if (convolve!=0) {
					star_prob += (Probability.stPsgConvolved(star_coords, stream_parameters[i], wedge, convolve)/stream_integrals[i])*exp_stream_weights[i];
				}
				else {
					star_prob += (Probability.stPsg(star_coords, stream_parameters[i], wedge)/stream_integrals[i])*exp_stream_weights[i];
				}
			}
			if (convolve!=0) {
				star_prob += (Probability.stPbxConvolved(star_coords, background_parameters, convolve)/background_integral)*exp_background_weight;
			}
			else {
				star_prob += (Probability.stPbx(star_coords, background_parameters)/background_integral)*exp_background_weight;
			}
			star_prob /= sum_exp_weights;
			if (Double.isNaN(star_prob)) {
				System.err.println("ERROR: star_prob is NAN");
				likelihood = star_prob;
				return new double[]{ star_prob, num_zero, bad_jacobians, max_points };
			}
			else if (star_prob>0.0) {
				likelihood += Math.log(star_prob)/Math.log(10);
			}
			else {
				System.err.println("calculated negative star_prob: "+star_prob+", sum_exp_weights: "+sum_exp_weights);
				num_zero++;
				likelihood -= 238.0;
			}
		}
		return new double[]{ likelihood, num_zero, bad_jacobians, max_points };
	}
	public void separation_function() {
		System.err.println("Integral complete.\n Beginning probability calculations...");
		int q = 0;
		double nstars = 0.0;
		double total = 0.0;
		double sprob;
		double prob_s;
		double prob_b;
		double pbx;
		double psg;
		File file = new File("streamplotStars.txt");
		boolean twoPanel = true;
		try {
			FileOutputStream fos = new FileOutputStream(file);
			DataOutputStream outfile = new DataOutputStream(fos);
			double[] dortho = { 0.0, 0.0, 1.0 };
			double[] dnormal = new double[3];
			Coordinates.stripe_normal(wedge, dnormal);
			double[][] cmatrix = new double[3][3];
			this.get_transform(dnormal, dortho, cmatrix);
			System.err.println("\nTransformation matrix:");
			System.err.println("{ "+cmatrix[0][0]+", "+cmatrix[0][1]+", "+cmatrix[0][2]+" }");
			System.err.println("{ "+cmatrix[1][0]+", "+cmatrix[1][1]+", "+cmatrix[1][2]+" }");
			System.err.println("{ "+cmatrix[2][0]+", "+cmatrix[2][1]+", "+cmatrix[2][2]+" }");
			double d = Probability.dotp(dnormal, xsun);
			System.err.println("bint = "+background_integral+", "+"sint = "+stream_integrals[0]);
			double epsilon_s = Math.exp(stream_weights[0])/(1.0+Math.exp(stream_weights[0]));
			double epsilon_b = 1.0/(1+Math.exp(stream_weights[0]));
			System.err.println("epsilon_s = "+epsilon_s);
			System.err.println("epsilon_b = "+epsilon_b);
			for (int i = 0; i<max_points; i++){
				double[] star_coords = star_points[i];
				if (twoPanel==true) {
					if (convolve!=0) {
						prob_s = Probability.stPsgConvolved(star_coords, stream_parameters[0], wedge, convolve);
						prob_b = Probability.stPbxConvolved(star_coords, background_parameters, convolve);
					}
					else {
						prob_s = Probability.stPsg(star_coords, stream_parameters[0], wedge);
						prob_b = Probability.stPbx(star_coords, background_parameters);
					}
					pbx = epsilon_b*prob_b/background_integral;
					psg = epsilon_s*prob_s/stream_integrals[0];
					sprob = psg/(psg+pbx);
					nstars += sprob;
				}
				else {
					sprob = 1.0;
					nstars += sprob;
				}
				int s_ok = Probability.prob_ok(sprob);
				if (s_ok==1) q++;
				double[] starxyz;
				starxyz = Coordinates.lbr2xyz(star_coords);
				double[] starxyzTransform;
				starxyzTransform = this.transform_point(starxyz, cmatrix);
				outfile.writeBytes(s_ok+" "+starxyzTransform[0]+" "+starxyzTransform[1]+" "+starxyzTransform[2]+"\n");
				total += 1.0;
				if ((total%10000)==0) {
					System.err.println(total);
				}
			}
			System.err.println(total+" total stars, "+nstars+" in stream ("+nstars/total*100+"%)");
			System.err.println(q+" stars seperated into stream");
			outfile.close();
			System.err.println("Output written to: "+file);
		}
		catch (Exception e) {
			System.err.println("Error printing to file "+e);
			e.printStackTrace();
			System.exit(0);
		}

	}
	public void get_transform(double[] f, double[] t, double[][] mat) {
		double axis[] = new double[3];
		Probability.crossp(f, t, axis);
		Probability.normalize(axis);
		double angle = Probability.vecangle(f, t);
		double sin_a = Math.sin(angle/2.0);
		double x = axis[0]*sin_a;
		double y = axis[1]*sin_a;
		double z = axis[2]*sin_a;
		double w = Math.cos(angle/2.0);
		mat[0][0] = 1.0-2.0*(y*y+z*z);
		mat[0][1] = 2.0*(x*y-z*w);
		mat[0][2] = 2.0*(x*z+y*w);
		mat[1][0] = 2.0*(x*y+z*w);
		mat[1][1] = 1.0-2.0*(x*x+z*z);
		mat[1][2] = 2.0*(y*z-x*w);
		mat[2][0] = 2.0*(x*z-y*w);
		mat[2][1] = 2.0*(y*z+x*w);
		mat[2][2] = 1.0-2.0*(x*x+y*y);
	}
	public void do_transform(double[] v, double[][] mat) {
		double[] newv = new double[3];
		newv[0] = Probability.dotp(mat[0], v);
		newv[1] = Probability.dotp(mat[1], v);
		newv[2] = Probability.dotp(mat[2], v);
		v[0] = newv[0];
		v[1] = newv[1];
		v[2] = newv[2];
	}
	public double[] transform_point(double[] point, double[][] cmat) {
		double mcutoff = 11.0;
		double[] logPoint;
		logPoint = Coordinates.xyz_mag(point, mcutoff);
		double newx = logPoint[0]-xsun[0];
		double newy = logPoint[1]-xsun[1];
		double newz = logPoint[2]-xsun[2];
		logPoint[0] = newx;
		logPoint[1] = newy;
		logPoint[2] = newz;
		this.do_transform(logPoint, cmat);
		return logPoint;
	}
	public void make_test_data() {
		File file = new File("td-bkg.txt");
		int numstars = 250000;
		System.err.println("Integral complete.");
		System.err.println("b_int = "+background_integral);
		System.err.println("s_int = "+stream_integrals[0]);
		System.err.println(" Beginning star generation...");
		try {
			FileOutputStream fos = new FileOutputStream(file);
			DataOutputStream outfile = new DataOutputStream(fos);
			double mu_max = 436.0;
			double mu_min = 307.0;
			double mu_inc = mu_max-mu_min;
			double nu_max = 1.25;
			double nu_min = -1.25;
			double r_max = 45.7;
			double r_min = 0.7;
			Random generator = new Random();
			double probMax = 58.0222/3125.19;
			int count = 0;
			int total = 0;
			double percentageDone = 0;
			double q;
			double rr;
			double mu;
			double nu;
			double r;
			double n;
			double[] ra = new double[1];
			double[] dec = new double[1];
			double[] l = new double[1];
			double[] b = new double[1];
			double[] lbr = new double[3];
			background_weight = Math.exp(background_weight);
			double sum_exp_weights = 0.0;
			stream_weights[0] = Math.exp(stream_weights[0]);
			sum_exp_weights += stream_weights[0];
			sum_exp_weights += background_weight;
			while (count<numstars) {
				total++;
				rr = generator.nextDouble();
				r = r_max*Math.pow(rr, 1.0/3.0);
				if (r>r_max||r<r_min) {
continue;				}
				mu = mu_min+mu_inc*generator.nextDouble();
				n = generator.nextDouble();
				nu = Math.asin(n*(Math.sin(nu_max)-Math.sin(nu_min))+Math.sin(nu_min));
				ATSurveyGeometry.atGCToEq(mu, nu, ra, dec, Coordinates.get_node(), Coordinates.wedge_incl(wedge));
				ATSurveyGeometry.atEqToGal(ra[0], dec[0], l, b);
				lbr[0] = l[0];
				lbr[1] = b[0];
				lbr[2] = r;
				double star_prob = 0.0;
				if (convolve!=0) {
					star_prob += (Probability.stPsgConvolved(lbr, stream_parameters[0], wedge, convolve)/stream_integrals[0])*stream_weights[0];
				}
				else {
					star_prob += (Probability.stPsg(lbr, stream_parameters[0], wedge)/stream_integrals[0])*stream_weights[0];
				}
				if (convolve!=0) {
					star_prob += (Probability.stPbxConvolved(lbr, background_parameters, convolve)/background_integral)*background_weight;
				}
				else {
					star_prob += (Probability.stPbx(lbr, background_parameters)/background_integral)*background_weight;
				}
				star_prob /= sum_exp_weights;
				q = generator.nextDouble();
				if (star_prob/probMax<q) {
continue;				}
				outfile.writeBytes(lbr[0]+" "+lbr[1]+" "+lbr[2]+"\n");
				count++;
				percentageDone = (double)count/numstars*100;
				if ((percentageDone%5)==0) {
					System.err.println((int)percentageDone+"% ("+count+")");
				}
			}
			System.err.println(total+" total stars generated.");
			System.err.println(count+" stars put into background");
			System.err.println(total-count+" stars discarded.");
			outfile.close();
			System.err.println("Testdata written to: "+file);
		}
		catch (Exception e) {
			System.err.println("Error printing to file "+e);
			e.printStackTrace();
			System.exit(0);
		}

	}
	public void readVolumeFromFile(String volume_file) {
		try {
			BufferedReader volume_reader = new BufferedReader(new FileReader(volume_file));
			this.wedge = read_integer("wedge", volume_reader);
			this.r_steps = read_integer("r_steps", volume_reader);
			this.mu_steps = read_integer("mu_steps", volume_reader);
			this.nu_steps = read_integer("nu_steps", volume_reader);
			volume_reader.close();
		}
		catch (Exception e) {
			System.err.println("Error reading star volume file: "+e);
			System.exit(0);
		}

		if (wedge<0) {
			nu_min = -90.0;
			nu_max = 90.0;
			mu_min = 0.0;
			mu_max = 360.0;
			r_min = 0;
			r_max = 91.2;
		}
		else {
			nu_min = -1.25;
			nu_max = 1.25;
			mu_min = Limits.getMuMin(wedge);
			mu_max = Limits.getMuMax(wedge);
			r_min = 5.0*(Math.log(0.7*100.0)/Math.log(10))+4.2;
			r_max = 5.0*(Math.log(45.7*100.0)/Math.log(10))+4.2;
		}
		r_step = (r_max-r_min)/r_steps;
		mu_step = (mu_max-mu_min)/mu_steps;
		nu_step = (nu_max-nu_min)/nu_steps;
		double slice_size = ((double)r_steps)/((double)max_rank);
		int min = (int)(rank*slice_size);
		int max = (int)((rank+1)*slice_size);
		int size = max-min;
		r_max = r_min+(max*r_step);
		r_min += min*r_step;
		r_steps = size;
	}
	public int read_integer(String value_name, BufferedReader volume_reader) throws Exception{
		StringTokenizer st = new StringTokenizer(volume_reader.readLine(), ",: ");
		String read_value_name = st.nextToken();
		if (!read_value_name.equals(value_name)) 		throw new Exception("Attempting to read "+value_name+" but encountered "+read_value_name);
		return Integer.parseInt(st.nextToken());
	}
	public void readStarsFromFile(String star_file) {
		try {
			System.out.println("Generating stars from file: "+star_file);
			BufferedReader in = new BufferedReader(new FileReader(star_file));
			String line = in.readLine();
			int num_stars = Integer.parseInt(line);
			star_points = new double[num_stars][3];
			for (int i = 0; i<num_stars; i++){
				line = in.readLine();
				StringTokenizer st = new StringTokenizer(line, " ");
				star_points[i][0] = Double.parseDouble(st.nextToken());
				star_points[i][1] = Double.parseDouble(st.nextToken());
				star_points[i][2] = Double.parseDouble(st.nextToken());
				if (i%50000==0) System.out.println(i+"...");
			}
		}
		catch (Exception e) {
			System.err.println("Error reading stars file: "+star_file);
			System.err.println("\tException generated: "+e);
			e.printStackTrace();
		}

		System.out.println("finished.");
		max_points = star_points.length;
		double slice_size = ((double)max_points)/((double)max_rank);
		int slice_max;
		int slice_min = (int)(rank*slice_size);
		if (rank==max_rank-1) {
			slice_max = star_points.length;
		}
		else {
			slice_max = (int)(((double)(rank+1))*slice_size);
		}
		int current_slice = slice_max-slice_min;
		double[][] temp_data = new double[current_slice][3];
		for (int j = 0; j<current_slice; j++){
			temp_data[j][0] = star_points[slice_min+j][0];
			temp_data[j][1] = star_points[slice_min+j][1];
			temp_data[j][2] = star_points[slice_min+j][2];
		}
		star_points = temp_data;
		max_points = current_slice;
	}
	public void set_parameters(double[] parameters) {
		this.convertToUnconstrained();
		int current = 0;
		for (int i = 0; i<background_parameters.length; i++){
			if (background_optimize_parameter[i]) {
				background_parameters[i] = parameters[current];
				current++;
			}
		}
		for (int i = 0; i<stream_parameters.length; i++){
			if (stream_weight_optimize[i]) {
				stream_weights[i] = parameters[current];
				current++;
			}
			for (int j = 0; j<stream_parameters[i].length; j++){
				if (stream_optimize_parameter[i][j]) {
					stream_parameters[i][j] = parameters[current];
					current++;
				}
			}
		}
		this.convertToConstrained();
	}
	public void convertToConstrained() {
		double sigma[] = new double[stream_parameters.length];
		for (int i = 0; i<stream_parameters.length; i++)sigma[i] = stream_parameters[i][4];
		double alpha = background_parameters[0];
		double q = background_parameters[1];
		double delta = background_parameters[3];
		for (int i = 0; i<stream_parameters.length; i++)sigma[i] = (0.5+20.0*Math.exp(-1.0*sigma[i]*sigma[i]));
		alpha = 3.0-alpha*alpha;
		q = .3+.7*Math.exp(-1.0*q*q);
		delta = delta*delta+.01;
		for (int i = 0; i<stream_parameters.length; i++){
			this.stream_parameters[i][4] = sigma[i];
			this.stream_weights[i] = Math.log(stream_weights[i]*stream_weights[i]);
		}
		this.background_parameters[0] = alpha;
		this.background_parameters[1] = q;
		this.background_parameters[3] = delta;
	}
	public void convertToUnconstrained() {
		double sigma[] = new double[stream_parameters.length];
		for (int i = 0; i<stream_parameters.length; i++){
			sigma[i] = stream_parameters[i][4];
		}
		double alpha = background_parameters[0];
		double q = background_parameters[1];
		double delta = background_parameters[3];
		for (int i = 0; i<stream_parameters.length; i++)sigma[i] = Math.sqrt(-Math.log((sigma[i]-.5)/20.0));
		alpha = Math.sqrt(3.0-alpha);
		q = Math.sqrt(-Math.log((q-.3)/.7));
		if ((delta-.01)<0) delta = 0;
		else delta = Math.sqrt(delta-.01);
		for (int i = 0; i<stream_parameters.length; i++){
			this.stream_parameters[i][4] = sigma[i];
			this.stream_weights[i] = Math.sqrt(Math.exp(stream_weights[i]));
		}
		this.background_parameters[0] = alpha;
		this.background_parameters[1] = q;
		this.background_parameters[3] = delta;
	}
	public void readParametersFromFile(String parameter_file) {
		try {
			BufferedReader parameterReader = new BufferedReader(new FileReader(parameter_file));
			StringTokenizer st = new StringTokenizer(parameterReader.readLine(), " :");
			st.nextToken();
			convolve = Integer.parseInt(st.nextToken());
			st = new StringTokenizer(parameterReader.readLine(), " :");
			st.nextToken();
			int number_background_parameters = Integer.parseInt(st.nextToken());
			background_parameters = new double[number_background_parameters];
			background_h = new double[number_background_parameters];
			background_mutation_range = new double[number_background_parameters];
			background_parameter_min = new double[number_background_parameters];
			background_parameter_max = new double[number_background_parameters];
			background_optimize_parameter = new boolean[number_background_parameters];
			st = new StringTokenizer(parameterReader.readLine(), " :");
			if (!st.nextToken().equals("background_weight")) 			throw new Exception();
			background_weight = Double.parseDouble(st.nextToken());
			background_parameters = this.readArray("background_parameters", parameterReader.readLine(), number_background_parameters);
			background_h = this.readArray("background_h", parameterReader.readLine(), number_background_parameters);
			background_mutation_range = this.readArray("background_mutation_range", parameterReader.readLine(), number_background_parameters);
			background_parameter_min = this.readArray("background_parameter_min", parameterReader.readLine(), number_background_parameters);
			background_parameter_max = this.readArray("background_parameter_max", parameterReader.readLine(), number_background_parameters);
			background_optimize_parameter = this.readBooleanArray("optimize_parameter", parameterReader.readLine(), number_background_parameters);
			st = new StringTokenizer(parameterReader.readLine(), " :,");
			st.nextToken();
			int number_streams = Integer.parseInt(st.nextToken());
			int number_stream_parameters = Integer.parseInt(st.nextToken());
			stream_integrals = new double[number_streams];
			stream_weights = new double[number_streams];
			stream_weight_h = new double[number_streams];
			stream_weight_mutation_range = new double[number_streams];
			stream_weight_min = new double[number_streams];
			stream_weight_max = new double[number_streams];
			stream_weight_optimize = new boolean[number_streams];
			stream_parameters = new double[number_streams][number_stream_parameters];
			stream_h = new double[number_streams][number_stream_parameters];
			stream_mutation_range = new double[number_streams][number_stream_parameters];
			stream_parameter_min = new double[number_streams][number_stream_parameters];
			stream_parameter_max = new double[number_streams][number_stream_parameters];
			stream_optimize_parameter = new boolean[number_streams][number_stream_parameters];
			for (int i = 0; i<number_streams; i++){
				st = new StringTokenizer(parameterReader.readLine(), " :,");
				if (!st.nextToken().equals("stream_weight")) 				throw new Exception();
				stream_weights[i] = Double.parseDouble(st.nextToken());
				st = new StringTokenizer(parameterReader.readLine(), " :,");
				if (!st.nextToken().equals("stream_weight_h")) 				throw new Exception();
				stream_weight_h[i] = Double.parseDouble(st.nextToken());
				st = new StringTokenizer(parameterReader.readLine(), " :,");
				if (!st.nextToken().equals("stream_weight_mutation_range")) 				throw new Exception();
				stream_weight_mutation_range[i] = Double.parseDouble(st.nextToken());
				st = new StringTokenizer(parameterReader.readLine(), " :,");
				if (!st.nextToken().equals("stream_weight_min")) 				throw new Exception();
				stream_weight_min[i] = Double.parseDouble(st.nextToken());
				st = new StringTokenizer(parameterReader.readLine(), " :,");
				if (!st.nextToken().equals("stream_weight_max")) 				throw new Exception();
				stream_weight_max[i] = Double.parseDouble(st.nextToken());
				st = new StringTokenizer(parameterReader.readLine(), " :,");
				if (!st.nextToken().equals("optimize_weight")) 				throw new Exception();
				String value = st.nextToken();
				if (value.equals("0")||value.equals("false")) stream_weight_optimize[i] = false;
				else stream_weight_optimize[i] = true;
				stream_parameters[i] = this.readArray("stream_parameters", parameterReader.readLine(), number_stream_parameters);
				stream_h[i] = this.readArray("stream_h", parameterReader.readLine(), number_stream_parameters);
				stream_mutation_range[i] = this.readArray("stream_mutation_range", parameterReader.readLine(), number_stream_parameters);
				stream_parameter_min[i] = this.readArray("stream_parameter_min", parameterReader.readLine(), number_stream_parameters);
				stream_parameter_max[i] = this.readArray("stream_parameter_max", parameterReader.readLine(), number_stream_parameters);
				stream_optimize_parameter[i] = this.readBooleanArray("optimize_parameter", parameterReader.readLine(), number_stream_parameters);
			}
			parameterReader.close();
		}
		catch (Exception e) {
			System.err.println("Error reading from parameter file: "+parameter_file);
			System.err.println("\tException: "+e);
			e.printStackTrace();
		}

	}
	public double[] readArray(String array_name, String line, int size) throws Exception{
		StringTokenizer st = new StringTokenizer(line, " :,");
		if (!st.nextToken().equals(array_name)) 		throw new Exception();
		double[] values = new double[size];
		for (int i = 0; i<size; i++)values[i] = Double.parseDouble(st.nextToken());
		return values;
	}
	public boolean[] readBooleanArray(String array_name, String line, int size) throws Exception{
		StringTokenizer st = new StringTokenizer(line, " :,");
		if (!st.nextToken().equals(array_name)) 		throw new Exception();
		boolean[] values = new boolean[size];
		for (int i = 0; i<size; i++){
			String value = st.nextToken();
			if (value.equals("0")||value.equals("false")) {
				values[i] = false;
			}
			else {
				values[i] = true;
			}
		}
		return values;
	}
	public void printParameters(OutputStream out) {
		try {
			DataOutputStream outfile = new DataOutputStream(out);
			outfile.writeBytes("convolve: "+convolve+"\n");
			outfile.writeBytes("number_parameters: "+background_parameters.length+"\n");
			outfile.writeBytes("background_weight: "+background_weight+"\n");
			this.writeArray("background_parameters", background_parameters, outfile);
			this.writeArray("background_h", background_h, outfile);
			this.writeArray("background_mutation_range", background_mutation_range, outfile);
			this.writeArray("background_parameter_min", background_parameter_min, outfile);
			this.writeArray("background_parameter_max", background_parameter_max, outfile);
			this.writeArray("optimize_parameter", background_optimize_parameter, outfile);
			outfile.writeBytes("number_streams: "+stream_parameters.length+", "+stream_parameters[0].length+"\n");
			for (int i = 0; i<stream_parameters.length; i++){
				outfile.writeBytes("stream_weight: "+stream_weights[i]+"\n");
				outfile.writeBytes("stream_weight_h: "+stream_weight_h[i]+"\n");
				outfile.writeBytes("stream_weight_mutation_range: "+stream_weight_mutation_range[i]+"\n");
				outfile.writeBytes("stream_weight_min: "+stream_weight_min[i]+"\n");
				outfile.writeBytes("stream_weight_max: "+stream_weight_max[i]+"\n");
				outfile.writeBytes("optimize_weight: "+stream_weight_optimize[i]+"\n");
				this.writeArray("stream_parameters", stream_parameters[i], outfile);
				this.writeArray("stream_h", stream_h[i], outfile);
				this.writeArray("stream_mutation_range", stream_mutation_range[i], outfile);
				this.writeArray("stream_parameter_min", stream_parameter_min[i], outfile);
				this.writeArray("stream_parameter_max", stream_parameter_max[i], outfile);
				this.writeArray("optimize_parameter", stream_optimize_parameter[i], outfile);
			}
		}
		catch (Exception e) {
			System.err.println("Error printing parameters to OutputStream: "+e);
			e.printStackTrace();
			System.exit(0);
		}

	}
	public void writeArray(String name, double[] array, DataOutputStream outfile) throws Exception{
		int i;
		outfile.writeBytes(name+": ");
		for (i = 0; i<array.length-1; i++)outfile.writeBytes(array[i]+", ");
		outfile.writeBytes(array[i]+"\n");
	}
	public void writeArray(String name, boolean[] array, DataOutputStream outfile) throws Exception{
		int i;
		outfile.writeBytes(name+": ");
		for (i = 0; i<array.length-1; i++)outfile.writeBytes(array[i]+", ");
		outfile.writeBytes(array[i]+"\n");
	}
	public void printParameters(String file) {
		try {
			FileOutputStream outfile = new FileOutputStream(file);
			{
				// printParameters(outfile)
				{
					Message __message = new Message( self, self, "printParameters", new Object[]{ outfile }, null, null);
					__messages.add( __message );
				}
			}
			outfile.close();
		}
		catch (Exception e) {
			System.err.println("Error printing parameters to FileWriter: "+e);
			e.printStackTrace();
			System.exit(0);
		}

	}
}