package gmle.salsa.framework;

import java.io.*;
import java.util.*;

public class ActorLocations implements java.io.Serializable {
	String name_server;
	String[] theaters;
	int[] actors_per_theater;
	int total_actors;

	public	int		getTotalActors()	{ return total_actors; }
	public	int[]		getActorsPerTheater()	{ return actors_per_theater; }
	public	String		getNameServer()		{ return name_server; }
	public	String[]	getTheaters()		{ return theaters; }

	public ActorLocations(String theater_file) {
		total_actors = 0;
		try {   
			BufferedReader in = new BufferedReader(new FileReader(theater_file));
			String line = in.readLine();

			name_server = "uan://" + line + "/";
			line = in.readLine();

			Vector theaters_vector = new Vector();
			Vector actors_per_theater_vector = new Vector();
			while (line != null) {
				StringTokenizer st = new StringTokenizer(line, " ");
				theaters_vector.add(st.nextToken());
				actors_per_theater_vector.add(st.nextToken());
				line = in.readLine();
			}
			theaters = new String[theaters_vector.size()];
			for (int j = 0; j < theaters_vector.size(); j++) {
				theaters[j] = "rmsp://" + (String)theaters_vector.get(j) + "/";
			}
			actors_per_theater = new int[actors_per_theater_vector.size()];
			for (int j = 0; j < actors_per_theater_vector.size(); j++) {
				actors_per_theater[j] = Integer.parseInt((String)actors_per_theater_vector.get(j));
				total_actors += actors_per_theater[j];
			}
		} catch (Exception e) {
			System.err.println("Error reading theaters file: " + e);
			e.printStackTrace();
		}       
	}        
}

