package gmle.salsa.framework;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.LiteActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;

public class GeneticSearchState extends LiteActorState  {
	public GeneticSearchState(UAN uan) {
		super(uan);
		self = new GeneticSearch(getUAN());
	}

	public GeneticSearchState(UAL ual) {
		super(ual);
		self = new GeneticSearch(getUAL());
	}

	public GeneticSearchState(String identifier) {
		super(identifier);
		self = new GeneticSearch(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("init_data") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof String) && (arguments[1] == null || arguments[1] instanceof String)) {
			init_data((String)arguments[0], (String)arguments[1]);
			return null;
		}  else if (methodName.equals("init_data") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof String) && (arguments[1] == null || arguments[1] instanceof Integer)) {
			init_data((String)arguments[0], ((Integer)arguments[1]).intValue());
			return null;
		}  else if (methodName.equals("initialize") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Object[])) {
			initialize((Object[])arguments[0]);
			return null;
		}  else if (methodName.equals("genetic_search") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof double[]) && (arguments[1] == null || arguments[1] instanceof double[])) {
			return genetic_search((double[])arguments[0], (double[])arguments[1]);
		}  else if (methodName.equals("evaluation_current_population") && arguments.length == 0) {
			evaluation_current_population();
			return null;
		}  else if (methodName.equals("set_current_likelihood") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Object[])) {
			set_current_likelihood((Object[])arguments[0]);
			return null;
		}  else if (methodName.equals("search") && arguments.length == 0) {
			return search();
		}  else if (methodName.equals("set_evaluation_output") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String)) {
			set_evaluation_output((String)arguments[0]);
			return null;
		}  else if (methodName.equals("track_evaluate") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof double[])) {
			return new Double(track_evaluate((double[])arguments[0]));
		}  else if (methodName.equals("write_result") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Double) && (arguments[1] == null || arguments[1] instanceof double[])) {
			return new Double(write_result(((Double)arguments[0]).doubleValue(), (double[])arguments[1]));
		}  else if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		} else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	void construct() {}

	int elite_population_size = 5;
	int population_size = 20;
	double mutation_chance = 0.3;
	double mutation_strength = 1.0;
	double reproduce_chance = 0.7;
	int current_iteration = 0;
	int maximum_iterations = 10000;
	double probability_cutoff = 0.001;
	int stopping_population_size = 20;
	double stopping_population_probability_threshold = 0.00001;
	MLEvaluator evaluator;
	public void init_data(String evaluatorClass, String theaters_file) {
		this.evaluator = MLEvaluator.construct(self, null, null, -1, new Object[]{evaluatorClass, theaters_file});
	}
	public void init_data(String evaluatorClass, int number_actors) {
		this.evaluator = MLEvaluator.construct(self, null, null, -1, new Object[]{evaluatorClass, number_actors});
	}
	public void initialize(Object[] init_params) {
		{
			// evaluator<-initialize(init_params)
			{
				Message __message = new Message( self, evaluator, "initialize", new Object[]{ init_params }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	double[] parameter_min;
	double[] parameter_max;
	public double[] genetic_search(double[] parameter_min, double[] parameter_max) {
		this.parameter_min = parameter_min;
		this.parameter_max = parameter_max;
		current_population_likelihood = new double[parameter_min.length];
		previous_population_likelihood = new double[parameter_min.length];
		current_population = new double[population_size][parameter_min.length];
		previous_population = new double[population_size][parameter_min.length];
		for (int i = 0; i<current_population.length; i++){
			for (int j = 0; j<current_population.length; j++){
				current_population[i][j] = parameter_min[j]+((parameter_max[j]-parameter_min[j])*Math.random());
			}
		}
		{
			Token token_2_0 = new Token();
			Token token_2_1 = new Token();
			// evaluator<-init_data()
			{
				Message __message = new Message( self, evaluator, "init_data", new Object[]{  }, null, token_2_0);
				__messages.add( __message );
			}
			// evaluate_current_population()
			{
				Message __message = new Message( self, self, "evaluate_current_population", new Object[]{  }, token_2_0, token_2_1);
				__messages.add( __message );
			}
			// search()
			{
				Message __message = new Message( self, self, "search", new Object[]{  }, token_2_1, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	double[] current_population_likelihood;
	double[][] current_population;
	double[] previous_population_likelihood;
	double[][] previous_population;
	public void evaluation_current_population() {
		{
			Token token_2_0 = new Token();
			// join block
			token_2_0.setJoinDirector();
			for (int i = 0; i<current_population.length; i++){
				{
					// evaluator<-evaluate(current_population[i])
					{
						Message __message = new Message( self, evaluator, "evaluate", new Object[]{ current_population[i] }, null, token_2_0);
						__messages.add( __message );
					}
				}
			}
			token_2_0.createJoinDirector();
			// set_current_likelihood(token)
			{
				Message __message = new Message( self, self, "set_current_likelihood", new Object[]{ token_2_0 }, token_2_0, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public void set_current_likelihood(Object[] results) {
		for (int i = 0; i<results.length; i++){
			current_population_likelihood[i] = ((Double)results[i]).doubleValue();
		}
	}
	public double[] search() {
		for (int i = 0; i<current_population_likelihood.length; i++){
			previous_population_likelihood[i] = current_population_likelihood[i];
			for (int j = 0; j<current_population[i].length; j++){
				previous_population[i][j] = current_population[i][j];
			}
		}
		return new double[10];
	}
	BufferedWriter evaluation_file;
	public void set_evaluation_output(String filename) {
		try {
			this.evaluation_file = new BufferedWriter(new FileWriter(new File(filename)));
		}
		catch (Exception e) {
			System.err.println("Unable to open evaluation output file: "+filename);
			System.err.println(e);
			e.printStackTrace();
			System.exit(0);
		}

	}
	int evaluations_done = 0;
	public double track_evaluate(double[] parameters) {
		Token result = new Token("result");
		{
			// token result = evaluator<-evaluate(parameters)
			{
				Message __message = new Message( self, evaluator, "evaluate", new Object[]{ parameters }, null, result);
				__messages.add( __message );
			}
		}
		{
			// write_result(result, parameters)
			{
				Message __message = new Message( self, self, "write_result", new Object[]{ result, parameters }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public double write_result(double result, double[] parameters) {
		if (evaluation_file!=null) {
			evaluations_done++;
			try {
				evaluation_file.write(evaluations_done+" : "+result+" :");
				for (int i = 0; i<parameters.length; i++){
					evaluation_file.write(" "+parameters[i]);
				}
				evaluation_file.write("\n");
				evaluation_file.flush();
			}
			catch (Exception e) {
				System.err.println("Unable to write to evaluation output file");
				System.err.println(e);
				e.printStackTrace();
				System.exit(0);
			}

		}
		return result;
	}
}