package gmle.salsa.framework;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.LiteActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.File;

public class GradientDescentState extends LiteActorState  {
	public GradientDescentState(UAN uan) {
		super(uan);
		self = new GradientDescent(getUAN());
	}

	public GradientDescentState(UAL ual) {
		super(ual);
		self = new GradientDescent(getUAL());
	}

	public GradientDescentState(String identifier) {
		super(identifier);
		self = new GradientDescent(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("set_evaluation_output") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String)) {
			set_evaluation_output((String)arguments[0]);
			return null;
		}  else if (methodName.equals("track_evaluate") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Matrix)) {
			return new Double(track_evaluate((Matrix)arguments[0]));
		}  else if (methodName.equals("track_evaluate") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof double[])) {
			return new Double(track_evaluate((double[])arguments[0]));
		}  else if (methodName.equals("write_result") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Double) && (arguments[1] == null || arguments[1] instanceof double[])) {
			return new Double(write_result(((Double)arguments[0]).doubleValue(), (double[])arguments[1]));
		}  else if (methodName.equals("initialize") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Object[])) {
			initialize((Object[])arguments[0]);
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof String) && (arguments[1] == null || arguments[1] instanceof String)) {
			construct((String)arguments[0], (String)arguments[1]);
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof String) && (arguments[1] == null || arguments[1] instanceof Integer)) {
			construct((String)arguments[0], ((Integer)arguments[1]).intValue());
			return null;
		}  else if (methodName.equals("gradient_descent") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof double[]) && (arguments[1] == null || arguments[1] instanceof double[])) {
			return gradient_descent((double[])arguments[0], (double[])arguments[1]);
		}  else if (methodName.equals("conjugate_gradient_descent") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof double[]) && (arguments[1] == null || arguments[1] instanceof double[])) {
			return conjugate_gradient_descent((double[])arguments[0], (double[])arguments[1]);
		}  else if (methodName.equals("hessian_conjugate_gradient_descent") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof double[]) && (arguments[1] == null || arguments[1] instanceof double[])) {
			return hessian_conjugate_gradient_descent((double[])arguments[0], (double[])arguments[1]);
		}  else if (methodName.equals("get_gradient") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof double[])) {
			return get_gradient((double[])arguments[0]);
		}  else if (methodName.equals("dummy") && arguments.length == 0) {
			dummy();
			return null;
		}  else if (methodName.equals("set_gradient") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Integer) && (arguments[1] == null || arguments[1] instanceof Double)) {
			set_gradient(((Integer)arguments[0]).intValue(), ((Double)arguments[1]).doubleValue());
			return null;
		}  else if (methodName.equals("combine_gradient") && arguments.length == 0) {
			return combine_gradient();
		}  else if (methodName.equals("descent") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof double[])) {
			return descent((double[])arguments[0]);
		}  else if (methodName.equals("descent_loop") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Double) && (arguments[1] == null || arguments[1] instanceof Matrix)) {
			return descent_loop(((Double)arguments[0]).doubleValue(), (Matrix)arguments[1]);
		}  else if (methodName.equals("descent_loop2") && arguments.length == 3 && (arguments[0] == null || arguments[0] instanceof Double) && (arguments[1] == null || arguments[1] instanceof Matrix) && (arguments[2] == null || arguments[2] instanceof Matrix)) {
			return descent_loop2(((Double)arguments[0]).doubleValue(), (Matrix)arguments[1], (Matrix)arguments[2]);
		}  else if (methodName.equals("line_search") && arguments.length == 3 && (arguments[0] == null || arguments[0] instanceof Matrix) && (arguments[1] == null || arguments[1] instanceof Matrix) && (arguments[2] == null || arguments[2] instanceof Double)) {
			return line_search((Matrix)arguments[0], (Matrix)arguments[1], ((Double)arguments[2]).doubleValue());
		}  else if (methodName.equals("line_search_loop1") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Double) && (arguments[1] == null || arguments[1] instanceof Double)) {
			return line_search_loop1(((Double)arguments[0]).doubleValue(), ((Double)arguments[1]).doubleValue());
		}  else if (methodName.equals("line_search_loop2") && arguments.length == 3 && (arguments[0] == null || arguments[0] instanceof Double) && (arguments[1] == null || arguments[1] instanceof Double) && (arguments[2] == null || arguments[2] instanceof Double)) {
			return line_search_loop2(((Double)arguments[0]).doubleValue(), ((Double)arguments[1]).doubleValue(), ((Double)arguments[2]).doubleValue());
		}  else if (methodName.equals("line_search_loop3") && arguments.length == 0) {
			return line_search_loop3();
		}  else if (methodName.equals("line_search_loop3_body") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Double)) {
			return line_search_loop3_body(((Double)arguments[0]).doubleValue());
		}  else if (methodName.equals("line_search_loop3a") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Double)) {
			return line_search_loop3a(((Double)arguments[0]).doubleValue());
		}  else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	int jump = 2;
	int nquad = 3;
	double targ = 0.1;
	double tolgrad = 0.00000001;
	double tolsearch = 0.000000001;
	double tol = tolgrad;
	double tols = tolsearch;
	int bold = 10;
	int nhessian = 10000;
	double lam = 0.1;
	double tolf = tol*tols;
	int max_line_searches = 10000;
	long start_time;
	String search_type;
	BufferedWriter evaluation_file;
	MLEvaluator evaluator;
	public void set_evaluation_output(String filename) {
		try {
			System.err.println("setting evaluation output file to: "+filename);
			this.evaluation_file = new BufferedWriter(new FileWriter(new File(filename)));
		}
		catch (Exception e) {
			System.err.println("Unable to open evaluation output file: "+filename);
			System.err.println(e);
			e.printStackTrace();
			System.exit(0);
		}

	}
	int evaluations_done = 0;
	public double track_evaluate(Matrix matrix) {
		{
			// track_evaluate(matrix.to_array())
			{
				Message __message = new Message( self, self, "track_evaluate", new Object[]{ matrix.to_array() }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public double track_evaluate(double[] parameters) {
		Token result = new Token("result");
		{
			// token result = evaluator<-evaluate(parameters)
			{
				Message __message = new Message( self, evaluator, "evaluate", new Object[]{ parameters }, null, result);
				__messages.add( __message );
			}
		}
		{
			// write_result(result, parameters)
			{
				Message __message = new Message( self, self, "write_result", new Object[]{ result, parameters }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public double write_result(double result, double[] parameters) {
		if (evaluation_file!=null) {
			evaluations_done++;
			try {
				evaluation_file.write(evaluations_done+" : "+result+" :");
				for (int i = 0; i<parameters.length; i++){
					evaluation_file.write(" "+parameters[i]);
				}
				evaluation_file.write("\n");
				evaluation_file.flush();
			}
			catch (Exception e) {
				System.err.println("Unable to write to evaluation output file");
				System.err.println(e);
				e.printStackTrace();
				System.exit(0);
			}

		}
		else {
			evaluations_done++;
		}
		double evals_per_sec = ((double)evaluations_done)/(((double)System.currentTimeMillis()-(double)start_time)/1000.0);
		System.out.println(evaluations_done+": evals/sec: "+evals_per_sec+", result: "+result);
		return result;
	}
	public void initialize(Object[] init_params) {
		{
			// evaluator<-initialize(init_params)
			{
				Message __message = new Message( self, evaluator, "initialize", new Object[]{ init_params }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public void construct(String evaluatorClass, String theaters_file){
		this.evaluator = MLEvaluator.construct(self, null, null, -1, new Object[]{evaluatorClass, theaters_file});
	}
	public void construct(String evaluatorClass, int number_actors){
		this.evaluator = MLEvaluator.construct(self, null, null, -1, new Object[]{evaluatorClass, number_actors});
	}
	double[] step_sizes;
	public double[] gradient_descent(double[] initial_parameters, double[] step_sizes) {
		search_type = "gd";
		this.step_sizes = step_sizes;
		{
			// descent(initial_parameters)
			{
				Message __message = new Message( self, self, "descent", new Object[]{ initial_parameters }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public double[] conjugate_gradient_descent(double[] initial_parameters, double[] step_sizes) {
		search_type = "cgd";
		this.step_sizes = step_sizes;
		{
			// descent(initial_parameters)
			{
				Message __message = new Message( self, self, "descent", new Object[]{ initial_parameters }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public double[] hessian_conjugate_gradient_descent(double[] initial_parameters, double[] step_sizes) {
		search_type = "cghd";
		this.step_sizes = step_sizes;
		{
			// descent(initial_parameters)
			{
				Message __message = new Message( self, self, "descent", new Object[]{ initial_parameters }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public Matrix get_gradient(double[] parameters) {
		incoming_gradient = new double[parameters.length*2];
		System.err.println("getting gradient of size: "+incoming_gradient.length);
		double[][] parameter_copies = new double[parameters.length*2][parameters.length];
		for (int i = 0; i<parameter_copies.length; i++){
			for (int j = 0; j<parameter_copies[i].length; j++){
				parameter_copies[i][j] = parameters[j];
			}
		}
		Token wait_token = new Token("wait_token");
		{
			// token wait_token = dummy()
			{
				Message __message = new Message( self, self, "dummy", new Object[]{  }, null, wait_token);
				__messages.add( __message );
			}
		}
		for (int i = 0; i<parameters.length; i++){
			System.err.println("setting copies: "+(i*2)+" and "+((i*2)+1));
			parameter_copies[i*2][i] += step_sizes[i];
			parameter_copies[(i*2)+1][i] -= step_sizes[i];
			{
				Token token_3_0 = new Token();
				Token token_3_1 = new Token();
				Token token_3_2 = new Token();
				// parameter_copies[i*2]track_evaluate:((wait_token))
				{
					Message __message = new Message( self, self, "track_evaluate", new Object[]{ parameter_copies[i*2] }, null, token_3_0);
					Object[] _propertyInfo = { wait_token };
					__message.setProperty( "waitfor", _propertyInfo );
					__messages.add( __message );
				}
				// set_gradient(new Integer(i*2), token)
				{
					Message __message = new Message( self, self, "set_gradient", new Object[]{ new Integer(i*2), token_3_0 }, token_3_0, token_3_1);
					__messages.add( __message );
				}
				// track_evaluate(parameter_copies[(i*2)+1])
				{
					Message __message = new Message( self, self, "track_evaluate", new Object[]{ parameter_copies[(i*2)+1] }, token_3_1, token_3_2);
					__messages.add( __message );
				}
				// wait_token = set_gradient(new Integer((i*2)+1), token)
				Token wait_token_next = new Token("set_gradient_next");
				{
					Message __message = new Message( self, self, "set_gradient", new Object[]{ new Integer((i*2)+1), token_3_2 }, token_3_2, wait_token_next);
					__messages.add( __message );
				}
				wait_token = wait_token_next;
			}
		}
		{
			// ()combine_gradient:((wait_token))
			{
				Message __message = new Message( self, self, "combine_gradient", new Object[]{  }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				Object[] _propertyInfo = { wait_token };
				__message.setProperty( "waitfor", _propertyInfo );
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public void dummy() {
	}
	double[] incoming_gradient;
	public void set_gradient(int position, double value) {
		incoming_gradient[position] = value;
	}
	public Matrix combine_gradient() {
		Matrix gradient = new Matrix(incoming_gradient.length/2, 1);
		System.err.println("calculated gradient:");
		for (int i = 0; i<incoming_gradient.length/2; i++){
			gradient.values[i][0] = (incoming_gradient[2*i]-incoming_gradient[(2*i)+1])/(2.0*step_sizes[i]);
			System.err.println("\tgradient.values["+i+"]: "+gradient.values[i][0]);
		}
		return gradient;
	}
	int num_line_searches = 0;
	double d_elf, f_prev;
	Matrix h, h_prev, d_pres, g_prev, d_prev, x_prev, d_elg, d_elx;
	public double[] descent(double[] initial_parameters) {
		g_prev = new Matrix(initial_parameters.length, 1);
		x_prev = new Matrix(initial_parameters.length, 1);
		d_prev = new Matrix(initial_parameters.length, 1);
		h_prev = new Matrix(initial_parameters.length, initial_parameters.length);
		for (int i = 0; i<initial_parameters.length; i++){
			h_prev.values[i][i] = 1.0;
		}
		Matrix x_pres = new Matrix(initial_parameters.length, 1);
		for (int i = 0; i<initial_parameters.length; i++){
			x_pres.values[i][0] = initial_parameters[i];
		}
		d_elg = new Matrix(initial_parameters.length, 1);
		d_elx = new Matrix(initial_parameters.length, 1);
		start_time = System.currentTimeMillis();
		f_prev = 0.0;
		num_line_searches = 0;
		Token f_pres = new Token("f_pres");
		{
			// token f_pres = track_evaluate(initial_parameters)
			{
				Message __message = new Message( self, self, "track_evaluate", new Object[]{ initial_parameters }, null, f_pres);
				__messages.add( __message );
			}
		}
		{
			// descent_loop(f_pres, x_pres)
			{
				Message __message = new Message( self, self, "descent_loop", new Object[]{ f_pres, x_pres }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public double[] descent_loop(double f_pres, Matrix x_pres) {
		System.err.print("iteration: "+num_line_searches+", f_pres: "+f_pres+", x_pres: ");
		x_pres.print();
		if (num_line_searches>=max_line_searches) {
			return x_pres.to_array();
		}
		else {
			num_line_searches++;
		}
		Token g_pres = new Token("g_pres");
		{
			// token g_pres = get_gradient(x_pres.to_array())
			{
				Message __message = new Message( self, self, "get_gradient", new Object[]{ x_pres.to_array() }, null, g_pres);
				__messages.add( __message );
			}
		}
		{
			// descent_loop2(new Double(f_pres), x_pres, g_pres)
			{
				Message __message = new Message( self, self, "descent_loop2", new Object[]{ new Double(f_pres), x_pres, g_pres }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public double[] descent_loop2(double f_pres, Matrix x_pres, Matrix g_pres) {
		d_elg = g_pres.sub(g_prev);
		d_elx = x_pres.sub(x_prev);
		d_elf = f_pres-f_prev;
		System.err.print("gradient: ");
		g_pres.print();
		if (search_type.equals("cghd")) {
			Matrix t1 = h_prev.mul(d_elg);
			Matrix t2 = d_elg.invert().mul(t1);
			Matrix t3 = d_elx.invert().mul(d_elg);
			Matrix temp1 = d_elx.rdiv(t3);
			Matrix temp2 = t1.rdiv(t2);
			Matrix u = temp1.sub(temp2);
			h = h_prev.add(d_elx.mul(d_elx.invert()).rdiv(t3).sub(t1.mul(t1.invert()).rdiv(t2)).add(t2.mul(u.mul(u.invert()))));
			double hm = h.mean();
			if (Double.isNaN(hm)) {
				System.err.println("HM is NAN, quitting\n");
				System.exit(0);
			}
			h_prev = h;
		}
		double ng = 0.0;
		double step = 0.0;
		if (search_type.equals("gd")) {
			d_pres = g_pres.neg();
			step = 0.5;
			ng = g_pres.norm();
		}
		else if (search_type.equals("cgd")) {
			Matrix bet;
			if (g_prev.norm()==0) {
				bet = new Matrix(1, 1);
			}
			else {
				bet = g_pres.invert().mul(g_pres.sub(g_prev)).rdiv(g_prev.invert().mul(g_prev));
			}
			d_pres = g_pres.neg().add(bet.mul(d_prev));
			ng = g_pres.norm();
			step = 0.5;
		}
		else if (search_type.equals("cghd")) {
			Matrix bet = g_pres.invert().mul(d_elg.rdiv(g_prev.invert().mul(g_prev)));
			if (Double.isInfinite(bet.values[0][0])) bet.values[0][0] = 0;
			Matrix d1 = g_pres.neg().add(bet.mul(d_prev));
			double nd1 = d1.norm();
			Matrix d2 = h.neg().mul(g_pres);
			double nd2 = d2.norm();
			d_pres = d1.mul(lam/nd1).add(d2.rdiv(nd2)).rdiv(lam+1);
			ng = g_pres.norm();
			step = (lam*Math.abs(f_pres-targ)/ng+nd2)/(lam+1);
		}
		Token x_fut = new Token( "x_fut", null );
		if (ng>tol) {
			System.err.print("direction: ");
			d_pres.print();
			{
				// x_fut = line_search(x_pres, d_pres, new Double(step))
				Token x_fut_next = new Token("line_search_next");
				{
					Message __message = new Message( self, self, "line_search", new Object[]{ x_pres, d_pres, new Double(step) }, null, x_fut_next);
					__messages.add( __message );
				}
				x_fut = x_fut_next;
			}
		}
		else if (Double.isNaN(ng-ng)) {
			System.err.println("ng is NaN, quitting\n");
			return x_pres.to_array();
		}
		else {
			System.err.println("gradient is below tolgrad, quitting\n");
			return x_pres.to_array();
		}
		Token f_fut = new Token("f_fut");
		{
			// token f_fut = track_evaluate(x_fut)
			{
				Message __message = new Message( self, self, "track_evaluate", new Object[]{ x_fut }, null, f_fut);
				__messages.add( __message );
			}
		}
		if (search_type.equals("cghd")) {
			if (d_elf>=-tolf) {
				lam = Math.pow(bold, 10);
				nhessian = num_line_searches+5;
			}
			else {
				if (lam>Math.pow(bold, -10)) {
					lam = lam/bold;
				}
			}
		}
		d_prev = d_pres;
		g_prev = g_pres;
		x_prev = x_pres;
		f_prev = f_pres;
		{
			// descent_loop(f_fut, x_fut)
			{
				Message __message = new Message( self, self, "descent_loop", new Object[]{ f_fut, x_fut }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	Matrix d;
	double step;
	double e1, e2, e3;
	Matrix x0, x1, x2, x3;
	public Matrix line_search(Matrix x0, Matrix d_ser, double step) {
		this.step = step;
		this.x0 = x0;
		d = d_ser.rdiv(d_ser.norm());
		Token e1_token = new Token("e1_token");
		{
			// token e1_token = track_evaluate(x0.to_array())
			{
				Message __message = new Message( self, self, "track_evaluate", new Object[]{ x0.to_array() }, null, e1_token);
				__messages.add( __message );
			}
		}
		Token e2_token = new Token("e2_token");
		{
			// token e2_token = track_evaluate(x0.add(d.mul(step)).to_array())
			{
				Message __message = new Message( self, self, "track_evaluate", new Object[]{ x0.add(d.mul(step)).to_array() }, null, e2_token);
				__messages.add( __message );
			}
		}
		{
			// line_search_loop1(e1_token, e2_token)
			{
				Message __message = new Message( self, self, "line_search_loop1", new Object[]{ e1_token, e2_token }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	double l1, l2, l3;
	public Matrix line_search_loop1(double e1_p, double e2_p) {
		this.e1 = e1_p;
		this.e2 = e2_p;
		if (e2<e1) {
			l1 = 0;
			l2 = 1;
			l3 = 2;
			Token e1_token = new Token("e1_token");
			{
				// token e1_token = track_evaluate(x0.add(d.mul(l1*step)))
				{
					Message __message = new Message( self, self, "track_evaluate", new Object[]{ x0.add(d.mul(l1*step)) }, null, e1_token);
					__messages.add( __message );
				}
			}
			Token e2_token = new Token("e2_token");
			{
				// token e2_token = track_evaluate(x0.add(d.mul(l2*step)))
				{
					Message __message = new Message( self, self, "track_evaluate", new Object[]{ x0.add(d.mul(l2*step)) }, null, e2_token);
					__messages.add( __message );
				}
			}
			Token e3_token = new Token("e3_token");
			{
				// token e3_token = track_evaluate(x0.add(d.mul(l3*step)))
				{
					Message __message = new Message( self, self, "track_evaluate", new Object[]{ x0.add(d.mul(l3*step)) }, null, e3_token);
					__messages.add( __message );
				}
			}
			{
				// line_search_loop2(e1_token, e2_token, e3_token)
				{
					Message __message = new Message( self, self, "line_search_loop2", new Object[]{ e1_token, e2_token, e3_token }, null, currentMessage.getContinuationToken());
					__message.setJoinPosition(currentMessage.getJoinPosition());
					__messages.add( __message );
				}
				throw new CurrentContinuationException();
			}
		}
		else {
			if (step<tol) {
				System.err.println("Line search could not progress beyond tolsearch\n");
				System.exit(0);
			}
			step /= 2.0;
		}
		Token e2_token = new Token("e2_token");
		{
			// token e2_token = track_evaluate(x0.add(d.mul(step)).to_array())
			{
				Message __message = new Message( self, self, "track_evaluate", new Object[]{ x0.add(d.mul(step)).to_array() }, null, e2_token);
				__messages.add( __message );
			}
		}
		{
			// line_search_loop1(new Double(e1), e2_token)
			{
				Message __message = new Message( self, self, "line_search_loop1", new Object[]{ new Double(e1), e2_token }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public Matrix line_search_loop2(double e1_p, double e2_p, double e3_p) {
		this.e1 = e1_p;
		this.e2 = e2_p;
		this.e3 = e3_p;
		if (e3>=e2) {
			loop3_iterations = 1;
			{
				// line_search_loop3()
				{
					Message __message = new Message( self, self, "line_search_loop3", new Object[]{  }, null, currentMessage.getContinuationToken());
					__message.setJoinPosition(currentMessage.getJoinPosition());
					__messages.add( __message );
				}
				throw new CurrentContinuationException();
			}
		}
		else if (Double.isNaN(e3-e3)) {
			System.err.println("premature exit of linesearch due to NaN\n");
			{
				// exit(0)
				{
					Message __message = new Message( self, self, "exit", new Object[]{ new Integer(0) }, null, null);
					__messages.add( __message );
				}
			}
		}
		else {
			l1 = l2;
			e1 = e2;
			l2 = l3;
			e2 = e3;
			l3 = jump*l3;
			Token e3_token = new Token("e3_token");
			{
				// token e3_token = track_evaluate(x0.add(d.mul(l3*step)))
				{
					Message __message = new Message( self, self, "track_evaluate", new Object[]{ x0.add(d.mul(l3*step)) }, null, e3_token);
					__messages.add( __message );
				}
			}
			{
				// line_search_loop2(new Double(e1), new Double(e2), e3_token)
				{
					Message __message = new Message( self, self, "line_search_loop2", new Object[]{ new Double(e1), new Double(e2), e3_token }, null, currentMessage.getContinuationToken());
					__message.setJoinPosition(currentMessage.getJoinPosition());
					__messages.add( __message );
				}
				throw new CurrentContinuationException();
			}
		}
		return null;
	}
	double a, b, es, lstar;
	int loop3_iterations;
	Matrix x;
	public Matrix line_search_loop3() {
		if (loop3_iterations>=nquad) {
			return x0.add(d.mul(lstar*step));
		}
		loop3_iterations++;
		a = (l1*l1)*(e2-e3)+(l2*l2)*(e3-e1)+(l3*l3)*(e1-e2);
		b = l1*(e2-e3)+l2*(e3-e1)+l3*(e1-e2);
		lstar = 0.5*(a/b);
		Token es_token = new Token("es_token");
		{
			// token es_token = track_evaluate(x0.add(d.mul(lstar*step)))
			{
				Message __message = new Message( self, self, "track_evaluate", new Object[]{ x0.add(d.mul(lstar*step)) }, null, es_token);
				__messages.add( __message );
			}
		}
		{
			// line_search_loop3_body(es_token)
			{
				Message __message = new Message( self, self, "line_search_loop3_body", new Object[]{ es_token }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public Matrix line_search_loop3_body(double es_p) {
		this.es = es_p;
		if (Double.isNaN(es)) {
			System.err.println("premature exit of linesearch due to NaN 2\n");
			System.exit(0);
		}
		if (lstar>l2+tol) {
			if (es>e2) {
				l3 = lstar;
				e3 = es;
			}
			else {
				l1 = l2;
				e1 = e2;
				l2 = lstar;
				e2 = es;
			}
		}
		else if (lstar<l2-tol) {
			if (es>e2) {
				l1 = lstar;
				e1 = es;
			}
			else {
				l3 = l2;
				e3 = e2;
				l2 = lstar;
				e2 = es;
			}
		}
		else {
			lstar = l2+tol;
			Token es_token = new Token("es_token");
			{
				// token es_token = track_evaluate(x0.add(d.mul(lstar*step)))
				{
					Message __message = new Message( self, self, "track_evaluate", new Object[]{ x0.add(d.mul(lstar*step)) }, null, es_token);
					__messages.add( __message );
				}
			}
			{
				// line_search_loop3a(es_token)
				{
					Message __message = new Message( self, self, "line_search_loop3a", new Object[]{ es_token }, null, currentMessage.getContinuationToken());
					__message.setJoinPosition(currentMessage.getJoinPosition());
					__messages.add( __message );
				}
				throw new CurrentContinuationException();
			}
		}
		{
			// line_search_loop3()
			{
				Message __message = new Message( self, self, "line_search_loop3", new Object[]{  }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public Matrix line_search_loop3a(double es_p) {
		this.es = es_p;
		if (es<e2) {
			l1 = l2;
			e1 = e2;
			l2 = lstar;
			e2 = es;
		}
		else {
			l3 = lstar;
			e3 = es;
		}
		{
			// line_search_loop3()
			{
				Message __message = new Message( self, self, "line_search_loop3", new Object[]{  }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
}