package gmle.salsa.framework;

// Import declarations generated by the SALSA compiler, do not modify.
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.services.ServiceFactory;

import salsa_lite.core.language.LiteActor;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.lang.reflect.Constructor;

public class MLEvaluator extends LiteActor  {
	public MLEvaluator(UAN uan) { super(uan); }
	public MLEvaluator(UAL ual) { super(ual); }
	public static MLEvaluator construct(ActorReference creator, UAN uan, String host, int port, Object[] arguments) {
		if (host == null) {
			host = ServiceFactory.getReception().getLocalHost();
			port = ServiceFactory.getReception().getLocalPort();
		}

		Actor actor;
		if (uan == null) {
			actor = new MLEvaluatorState(IdentifierGenerator.generateUniqueUAL(host, port));
		} else {
			actor = new MLEvaluatorState(uan);
		}
		MLEvaluator target;
		if (actor.getUAN() != null) target = new MLEvaluator(actor.getUAN());
		else target = new MLEvaluator(actor.getUAL());
		actor.setConstructMessage(new Message(creator, target, "construct", arguments, null, null, null));
		ServiceFactory.getStage().createActor(actor, host, port);
		return target;
	}

	public static void main(String[] arguments) {
		ServiceFactory.initialize();

		UAN uan = null;
		if (System.getProperty("actor_uan") != null) {
			try {
				uan = new UAN(System.getProperty("actor_uan"));
			} catch (MalformedUANException e) {
				System.err.println("Error starting actor, malformed uan given: " + System.getProperty("actor_uan"));
				System.err.println("\tException: " + e);
				return;
			}
		}
		String host = System.getProperty("actor_host");
		int port = -1;
		if (System.getProperty("actor_port") != null) port = Integer.parseInt(System.getProperty("actor_port"));
		if (host == null) {
			host = ServiceFactory.getReception().getLocalHost();
			port = ServiceFactory.getReception().getLocalPort();
		}

		Actor actor;
		MLEvaluator self;
		if (uan == null) {
			actor = new MLEvaluatorState(IdentifierGenerator.generateUniqueUAL(host, port));
			self = new MLEvaluator(actor.getUAL());
		} else {
			actor = new MLEvaluatorState(uan);
			self = new MLEvaluator(actor.getUAN());
		}
		actor.setConstructMessage(new Message(self, self, "act", new Object[]{ arguments }, null, null, null));
		ServiceFactory.getStage().createActor(actor, host, port);
	}
}
