package gmle.salsa.framework;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.LiteActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;

public class SimplexState extends LiteActorState  {
	public SimplexState(UAN uan) {
		super(uan);
		self = new Simplex(getUAN());
	}

	public SimplexState(UAL ual) {
		super(ual);
		self = new Simplex(getUAL());
	}

	public SimplexState(String identifier) {
		super(identifier);
		self = new Simplex(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("construct") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof String) && (arguments[1] == null || arguments[1] instanceof String)) {
			construct((String)arguments[0], (String)arguments[1]);
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof String) && (arguments[1] == null || arguments[1] instanceof Integer)) {
			construct((String)arguments[0], ((Integer)arguments[1]).intValue());
			return null;
		}  else if (methodName.equals("initialize") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Object[])) {
			initialize((Object[])arguments[0]);
			return null;
		}  else if (methodName.equals("simplex") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof double[][])) {
			simplex((double[][])arguments[0]);
			return null;
		}  else if (methodName.equals("set_y") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof double[])) {
			set_y((double[])arguments[0]);
			return null;
		}  else if (methodName.equals("calculate_psums") && arguments.length == 0) {
			calculate_psums();
			return null;
		}  else if (methodName.equals("step") && arguments.length == 0) {
			step();
			return null;
		}  else if (methodName.equals("augment") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Double)) {
			augment(((Double)arguments[0]).doubleValue());
			return null;
		}  else if (methodName.equals("collect") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Double)) {
			collect(((Double)arguments[0]).doubleValue());
			return null;
		}  else if (methodName.equals("contract") && arguments.length == 0) {
			contract();
			return null;
		}  else if (methodName.equals("reflect") && arguments.length == 0) {
			reflect();
			return null;
		}  else if (methodName.equals("finish") && arguments.length == 0) {
			finish();
			return null;
		}  else if (methodName.equals("set_evaluation_output") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String)) {
			set_evaluation_output((String)arguments[0]);
			return null;
		}  else if (methodName.equals("track_evaluate") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof double[][])) {
			return track_evaluate((double[][])arguments[0]);
		}  else if (methodName.equals("combine") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Object[])) {
			return combine((Object[])arguments[0]);
		}  else if (methodName.equals("track_evaluate") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof double[])) {
			return new Double(track_evaluate((double[])arguments[0]));
		}  else if (methodName.equals("write_result") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Double) && (arguments[1] == null || arguments[1] instanceof double[])) {
			return new Double(write_result(((Double)arguments[0]).doubleValue(), (double[])arguments[1]));
		}  else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	double ALPHA = -1.0;
	double BETA = 0.5;
	double GAMMA = 2.0;
	double ftol = 10e-8;
	int current_iteration = 0;
	int maximum_iterations = 10000;
	long start_time;
	double[] y;
	double[] psum;
	double[][] p;
	int number_parameters;
	int parameter_size;
	int highest, next_highest, lowest;
	double ytry, ysave;
	boolean isGrow = false;
	boolean isContract = false;
	boolean isReflect = false;
	MLEvaluator evaluator;
	public void construct(String evaluatorClass, String theaters_file){
		this.evaluator = MLEvaluator.construct(self, null, null, -1, new Object[]{evaluatorClass, theaters_file});
	}
	public void construct(String evaluatorClass, int number_actors){
		this.evaluator = MLEvaluator.construct(self, null, null, -1, new Object[]{evaluatorClass, number_actors});
	}
	public void initialize(Object[] init_params) {
		{
			// evaluator<-initialize(init_params)
			{
				Message __message = new Message( self, evaluator, "initialize", new Object[]{ init_params }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public void simplex(double[][] initial_parameters) {
		this.start_time = System.currentTimeMillis();
		p = initial_parameters;
		parameter_size = p[0].length;
		psum = new double[parameter_size];
		number_parameters = p.length;
		Token y_set = new Token("y_set");
		{
			Token token_2_0 = new Token();
			// track_evaluate(p)
			{
				Message __message = new Message( self, self, "track_evaluate", new Object[]{ p }, null, token_2_0);
				__messages.add( __message );
			}
			// token y_set = set_y(token)
			{
				Message __message = new Message( self, self, "set_y", new Object[]{ token_2_0 }, token_2_0, y_set);
				__messages.add( __message );
			}
		}
		{
			Token token_2_0 = new Token();
			// calculate_psums()
			{
				Message __message = new Message( self, self, "calculate_psums", new Object[]{  }, null, token_2_0);
				__messages.add( __message );
			}
			// ()step:((y_set))
			{
				Message __message = new Message( self, self, "step", new Object[]{  }, token_2_0, null);
				Object[] _propertyInfo = { y_set };
				__message.setProperty( "waitfor", _propertyInfo );
				__messages.add( __message );
			}
		}
	}
	public void set_y(double[] results) {
		if (y==null||y.length==results.length) {
			y = new double[results.length];
			for (int i = 0; i<y.length; i++)y[i] = results[i];
		}
		else {
			int current = 0;
			for (int i = 0; i<y.length; i++){
				if (i!=lowest) {
					y[i] = results[current];
					current++;
				}
			}
		}
	}
	public void calculate_psums() {
		int i;
		double sum;
		for (int j = 0; j<p[0].length; j++){
			sum = 0;
			for (i = 0; i<p.length; i++){
				sum += p[i][j];
			}
			psum[j] = sum;
		}
	}
	public void step() {
		highest = 0;
		lowest = 0;
		for (int i = 1; i<y.length; i++){
			if (y[i]<y[lowest]) lowest = i;
			if (y[i]>y[highest]) {
				next_highest = highest;
				highest = i;
			}
		}
		next_highest = highest;
		boolean set_lower = false;
		for (int i = 0; i<y.length; i++){
			if (!set_lower&&y[i]!=y[highest]) {
				next_highest = i;
				set_lower = true;
			}
			else if (set_lower&&y[i]>y[next_highest]&&y[i]!=y[highest]) {
				next_highest = i;
			}
		}
		System.err.println("Stepping.  highest ("+highest+"): "+y[highest]+", lowest ("+lowest+"): "+y[lowest]+", next highest ("+next_highest+"): "+y[next_highest]);
		double rtol = 2.0*Math.abs(y[highest]-y[lowest])/(Math.abs(y[highest])+Math.abs(y[lowest]));
		double ptol = 0.0;
		for (int i = 0; i<parameter_size; i++)ptol += Math.abs(p[highest][i]-p[lowest][i]);
		ptol /= parameter_size;
		if (current_iteration>maximum_iterations||(rtol<ftol&&ptol<ftol)) {
			System.err.println("current iteration: "+current_iteration+", maximum_iterations: "+maximum_iterations);
			System.err.println("rtol < ftol? "+rtol+" < "+ftol);
			System.err.println("ptol < ftol? "+ptol+" < "+ftol);
			{
				// finish()
				{
					Message __message = new Message( self, self, "finish", new Object[]{  }, null, null);
					__messages.add( __message );
				}
			}
		}
		else {
			isReflect = true;
			{
				// self<-augment(new Double(ALPHA))
				{
					Message __message = new Message( self, self, "augment", new Object[]{ new Double(ALPHA) }, null, null);
					__messages.add( __message );
				}
			}
		}
	}
	double[] ptry;
	public void augment(double factor) {
		System.err.println("Augmenting by: "+factor);
		double factor1 = (1.0-factor)/parameter_size;
		double factor2 = factor1-factor;
		ptry = new double[parameter_size];
		for (int i = 0; i<parameter_size; i++)ptry[i] = psum[i]*factor1-p[highest][i]*factor2;
		{
			Token token_2_0 = new Token();
			// track_evaluate(ptry)
			{
				Message __message = new Message( self, self, "track_evaluate", new Object[]{ ptry }, null, token_2_0);
				__messages.add( __message );
			}
			// collect(token)
			{
				Message __message = new Message( self, self, "collect", new Object[]{ token_2_0 }, token_2_0, null);
				__messages.add( __message );
			}
		}
	}
	public void collect(double value) {
		System.err.println("Collected: "+value);
		ytry = value;
		if (ytry<y[highest]) {
			y[highest] = ytry;
			for (int j = 0; j<parameter_size; j++){
				psum[j] += ptry[j]-p[highest][j];
				p[highest][j] = ptry[j];
			}
		}
		if (isReflect) {
			isReflect = false;
			{
				// reflect()
				{
					Message __message = new Message( self, self, "reflect", new Object[]{  }, null, null);
					__messages.add( __message );
				}
			}
		}
		else if (isGrow) {
			isGrow = false;
			{
				// step()
				{
					Message __message = new Message( self, self, "step", new Object[]{  }, null, null);
					__messages.add( __message );
				}
			}
		}
		else if (isContract) {
			if (ytry>=ysave) {
				isContract = false;
				{
					// contract()
					{
						Message __message = new Message( self, self, "contract", new Object[]{  }, null, null);
						__messages.add( __message );
					}
				}
			}
			else {
				{
					// step()
					{
						Message __message = new Message( self, self, "step", new Object[]{  }, null, null);
						__messages.add( __message );
					}
				}
			}
		}
	}
	public void contract() {
		System.err.println("Contracting.");
		int current = 0;
		for (int i = 0; i<p.length; i++){
			if (i!=lowest) {
				for (int j = 0; j<parameter_size; j++){
					psum[j] = 0.5*(p[i][j]+p[lowest][j]);
					p[i][j] = psum[j];
				}
				current++;
			}
		}
		{
			Token token_2_0 = new Token();
			Token token_2_1 = new Token();
			// track_evaluate(p)
			{
				Message __message = new Message( self, self, "track_evaluate", new Object[]{ p }, null, token_2_0);
				__messages.add( __message );
			}
			// set_y(token)
			{
				Message __message = new Message( self, self, "set_y", new Object[]{ token_2_0 }, token_2_0, token_2_1);
				__messages.add( __message );
			}
			// step()
			{
				Message __message = new Message( self, self, "step", new Object[]{  }, token_2_1, null);
				__messages.add( __message );
			}
		}
	}
	public void reflect() {
		System.err.println("Reflecting, ytry: "+ytry+", ysave: "+ysave+", lowest y["+lowest+"]: "+y[lowest]+", next highest y["+next_highest+"]: "+y[next_highest]);
		if (ytry<=y[lowest]) {
			isGrow = true;
			{
				// self<-augment(new Double(GAMMA))
				{
					Message __message = new Message( self, self, "augment", new Object[]{ new Double(GAMMA) }, null, null);
					__messages.add( __message );
				}
			}
		}
		else if (ytry>=y[next_highest]) {
			isContract = true;
			ysave = y[highest];
			{
				// self<-augment(new Double(BETA))
				{
					Message __message = new Message( self, self, "augment", new Object[]{ new Double(BETA) }, null, null);
					__messages.add( __message );
				}
			}
		}
		else {
			{
				// step()
				{
					Message __message = new Message( self, self, "step", new Object[]{  }, null, null);
					__messages.add( __message );
				}
			}
		}
	}
	public void finish() {
		System.err.println("Finished in "+((System.currentTimeMillis()-start_time)/1000.0)+" seconds.");
		System.err.println("\tcurrent iteration: "+current_iteration);
		System.err.println("\tbest evaluation: "+y[lowest]);
		System.err.println("\tbest parameters: ");
		for (int i = 0; i<p[lowest].length; i++){
			System.err.println("\t\t"+p[lowest][i]);
		}
	}
	BufferedWriter evaluation_file;
	public void set_evaluation_output(String filename) {
		try {
			this.evaluation_file = new BufferedWriter(new FileWriter(new File(filename)));
		}
		catch (Exception e) {
			System.err.println("Unable to open evaluation output file: "+filename);
			System.err.println(e);
			e.printStackTrace();
			System.exit(0);
		}

	}
	int evaluations_done = 0;
	public double[] track_evaluate(double[][] parameters) {
		{
			Token token_2_0 = new Token();
			// join block
			token_2_0.setJoinDirector();
			for (int i = 0; i<parameters.length; i++){
				{
					// track_evaluate(parameters[i])
					{
						Message __message = new Message( self, self, "track_evaluate", new Object[]{ parameters[i] }, null, token_2_0);
						__messages.add( __message );
					}
				}
			}
			token_2_0.createJoinDirector();
			// combine(token)
			{
				Message __message = new Message( self, self, "combine", new Object[]{ token_2_0 }, token_2_0, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public double[] combine(Object[] evaluate_results) {
		double[] dresults = new double[evaluate_results.length];
		for (int i = 0; i<evaluate_results.length; i++)dresults[i] = ((Double)evaluate_results[i]).doubleValue();
		return dresults;
	}
	public double track_evaluate(double[] parameters) {
		Token result = new Token("result");
		{
			// token result = evaluator<-evaluate(parameters)
			{
				Message __message = new Message( self, evaluator, "evaluate", new Object[]{ parameters }, null, result);
				__messages.add( __message );
			}
		}
		{
			// write_result(result, parameters)
			{
				Message __message = new Message( self, self, "write_result", new Object[]{ result, parameters }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public double write_result(double result, double[] parameters) {
		if (evaluation_file!=null) {
			evaluations_done++;
			try {
				evaluation_file.write(evaluations_done+" : "+result+" :");
				for (int i = 0; i<parameters.length; i++){
					evaluation_file.write(" "+parameters[i]);
				}
				evaluation_file.write("\n");
				evaluation_file.flush();
			}
			catch (Exception e) {
				System.err.println("Unable to write to evaluation output file");
				System.err.println(e);
				e.printStackTrace();
				System.exit(0);
			}

		}
		return result;
	}
}