package gml;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import gc.WeakReference;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

import salsa.resources.SystemService;

import salsa.resources.ActorService;

// End SALSA compiler generated import delcarations.

import language.MalleableActor;

public class MLWDirector extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		RunTime.receivedMessage();
		MLWDirector instance = (MLWDirector)new MLWDirector(uan, ual,null).construct();
		gc.WeakReference instanceRef=new gc.WeakReference(uan,ual);
		{
			Object[] _arguments = { args };

			//preAct() for local actor creation
			//act() for remote actor creation
			if (ual != null && !ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {instance.send( new Message(instanceRef, instanceRef, "act", _arguments, false) );}
			else {instance.send( new Message(instanceRef, instanceRef, "preAct", _arguments, false) );}
		}
		RunTime.finishedProcessingMessage();
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new MLWDirector(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return MLWDirector.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new MLWDirector(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return MLWDirector.getReferenceByLocation(new UAL(ual)); }
	public MLWDirector(boolean o, UAN __uan)	{ super(false,__uan); }
	public MLWDirector(boolean o, UAL __ual)	{ super(false,__ual); }
	public MLWDirector(UAN __uan,UniversalActor.State sourceActor)	{ this(__uan, null, sourceActor); }
	public MLWDirector(UAL __ual,UniversalActor.State sourceActor)	{ this(null, __ual, sourceActor); }
	public MLWDirector(UniversalActor.State sourceActor)		{ this(null, null, sourceActor);  }
	public MLWDirector()		{  }
	public MLWDirector(UAN __uan, UAL __ual, Object obj) {
		//decide the type of sourceActor
		//if obj is null, the actor must be the startup actor.
		//if obj is an actorReference, this actor is created by a remote actor

		if (obj instanceof UniversalActor.State || obj==null) {
			  UniversalActor.State sourceActor;
			  if (obj!=null) { sourceActor=(UniversalActor.State) obj;}
			  else {sourceActor=null;}

			  //remote creation message sent to a remote system service.
			  if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			    WeakReference sourceRef;
			    if (sourceActor!=null && sourceActor.getUAL() != null) {sourceRef = new WeakReference(sourceActor.getUAN(),sourceActor.getUAL());}
			    else {sourceRef = null;}
			    if (sourceActor != null) {
			      if (__uan != null) {sourceActor.getActorMemory().getForwardList().putReference(__uan);}
			      else if (__ual!=null) {sourceActor.getActorMemory().getForwardList().putReference(__ual);}

			      //update the source of this actor reference
			      setSource(sourceActor.getUAN(), sourceActor.getUAL());
			      activateGC();
			    }
			    createRemotely(__uan, __ual, "gml.MLWDirector", sourceRef);
			  }

			  // local creation
			  else {
			    State state = new State(__uan, __ual);

			    //assume the reference is weak
			    muteGC();

			    //the source actor is  the startup actor
			    if (sourceActor == null) {
			      state.getActorMemory().getInverseList().putInverseReference("rmsp://me");
			    }

			    //the souce actor is a normal actor
			    else if (sourceActor instanceof UniversalActor.State) {

			      // this reference is part of garbage collection
			      activateGC();

			      //update the source of this actor reference
			      setSource(sourceActor.getUAN(), sourceActor.getUAL());

			      /* Garbage collection registration:
			       * register 'this reference' in sourceActor's forward list @
			       * register 'this reference' in the forward acquaintance's inverse list
			       */
			      String inverseRefString=null;
			      if (sourceActor.getUAN()!=null) {inverseRefString=sourceActor.getUAN().toString();}
			      else if (sourceActor.getUAL()!=null) {inverseRefString=sourceActor.getUAL().toString();}
			      if (__uan != null) {sourceActor.getActorMemory().getForwardList().putReference(__uan);}
			      else if (__ual != null) {sourceActor.getActorMemory().getForwardList().putReference(__ual);}
			      else {sourceActor.getActorMemory().getForwardList().putReference(state.getUAL());}

			      //put the inverse reference information in the actormemory
			      if (inverseRefString!=null) state.getActorMemory().getInverseList().putInverseReference(inverseRefString);
			    }
			    state.updateSelf(this);
			    ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			    if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
			  }
		}

		//creation invoked by a remote message
		else if (obj instanceof ActorReference) {
			  ActorReference sourceRef= (ActorReference) obj;
			  State state = new State(__uan, __ual);
			  muteGC();
			  state.getActorMemory().getInverseList().putInverseReference("rmsp://me");
			  if (sourceRef.getUAN() != null) {state.getActorMemory().getInverseList().putInverseReference(sourceRef.getUAN());}
			  else if (sourceRef.getUAL() != null) {state.getActorMemory().getInverseList().putInverseReference(sourceRef.getUAL());}
			  state.updateSelf(this);
			  ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(),state);
			  if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor .State {
		public MLWDirector self;
		public void updateSelf(ActorReference actorReference) {
			((MLWDirector)actorReference).setUAL(getUAL());
			((MLWDirector)actorReference).setUAN(getUAN());
			self = new MLWDirector(false,getUAL());
			self.setUAN(getUAN());
			self.setUAL(getUAL());
			self.activateGC();
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "gml.MLWDirector$State" );
			addMethodsForClasses();
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				if (!message.getMethodName().equals("die")) {message.activateArgsGC(this);}
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		public MalleableActor[] createNewWorkers(int number_workers, String name_server, String theater) {
			MalleableActor[] newWorkers = new MalleableActor[number_workers];
			for (int i = 0; i<newWorkers.length; i++){
				UAN uan = new UAN(name_server+"split/split_worker_"+i);
				UAL ual = new UAL(theater+"split/split_worker_"+i);
				newWorkers[i] = ((MaxLikelihoodWorker)new MaxLikelihoodWorker(uan, ual,this).construct());
			}
			return newWorkers;
		}
		public MalleableActor[] createNewWorkers(int[] actors_per_theater, String[] theaters, String name_server) {
			int total_workers = 0;
			for (int i = 0; i<actors_per_theater.length; i++)total_workers += actors_per_theater[i];
			MalleableActor[] newWorkers = new MalleableActor[total_workers];
			int current = 0;
			for (int i = 0; i<theaters.length; i++){
				for (int j = 0; j<actors_per_theater[i]; j++){
					UAN uan = new UAN(name_server+"split/split_worker_"+current);
					UAL ual = new UAL(theaters[i]+"split/split_worker_"+current);
					newWorkers[current] = ((MaxLikelihoodWorker)new MaxLikelihoodWorker(uan, ual,this).construct());
					current++;
				}
			}
			return newWorkers;
		}
		public MalleableActor[] splitRedistributeData(MalleableActor[] workers, int[] desiredWorkerData, MalleableActor[] newWorkers, int[] desiredSplitData) {
			{
				Token token_2_0 = new Token();
				// join block
				token_2_0.setJoinDirector();
				for (int i = 0; i<workers.length; i++){
					{
						// workers[i]<-getDataSize()
						{
							Object _arguments[] = {  };
							Message message = new Message( self, workers[i], "getDataSize", _arguments, null, token_2_0 );
							__messages.add( message );
						}
					}
				}
				addJoinToken(token_2_0);
				// srdHelper(token, workers, desiredWorkerData, newWorkers, desiredSplitData)
				{
					Object _arguments[] = { token_2_0, workers, desiredWorkerData, newWorkers, desiredSplitData };
					Message message = new Message( self, self, "srdHelper", _arguments, token_2_0, currentMessage.getContinuationToken() );
					__messages.add( message );
				}
				throw new CurrentContinuationException();
			}
		}
		public MalleableActor[] srdHelper(Object[] wd, MalleableActor[] workers, int[] desiredWorkerData, MalleableActor[] newWorkers, int[] desiredSplitData) {
			int[] workerData = new int[wd.length];
			for (int i = 0; i<wd.length; i++)workerData[i] = (int)((Long)wd[i]).longValue();
			int currentWorker = 0;
			int currentTarget = 0;
			System.err.println("Performing Split:");
			System.err.println("\tnumber workers: "+workers.length);
			System.err.println("\tnumber newWorkers: "+newWorkers.length);
			System.err.println();
			{
				Token token_2_0 = new Token();
				// join block
				token_2_0.setJoinDirector();
				while (currentWorker<workers.length) {
					int dataToSend = workerData[currentWorker]-desiredWorkerData[currentWorker];
					System.err.println("\tworkerData["+currentWorker+"] = "+workerData[currentWorker]);
					System.err.println("\tdesiredWorkerData["+currentWorker+"] = "+desiredWorkerData[currentWorker]);
					System.err.println("\tcurrent worker["+currentWorker+"] sending "+dataToSend+" points.");
					while (dataToSend>0) {
						int toSend = Math.min(dataToSend, desiredSplitData[currentTarget]);
						System.err.println("\t\tdesiredSplitData["+currentTarget+"] = "+desiredSplitData[currentTarget]);
						System.err.println("\t\tsending "+toSend+" to current target["+currentTarget+"].");
						{
							Token token_5_0 = new Token();
							// workers[currentWorker]<-getData(new Integer(toSend))
							{
								Object _arguments[] = { new Integer(toSend) };
								Message message = new Message( self, workers[currentWorker], "getData", _arguments, null, token_5_0 );
								__messages.add( message );
							}
							// newWorkers[currentTarget]<-recieveData(token)
							{
								Object _arguments[] = { token_5_0 };
								Message message = new Message( self, newWorkers[currentTarget], "recieveData", _arguments, token_5_0, token_2_0 );
								__messages.add( message );
							}
						}
						desiredSplitData[currentTarget] -= toSend;
						if (desiredSplitData[currentTarget]==0) {currentTarget++;
}						dataToSend -= toSend;
					}
					currentWorker++;
				}
				MalleableActor[] combined = new MalleableActor[workers.length+newWorkers.length];
				System.arraycopy(workers, 0, combined, 0, workers.length);
				System.arraycopy(newWorkers, 0, combined, workers.length, newWorkers.length);
				addJoinToken(token_2_0);
				// identity(combined)
				{
					Object _arguments[] = { combined };
					Message message = new Message( self, self, "identity", _arguments, token_2_0, currentMessage.getContinuationToken() );
					__messages.add( message );
				}
				throw new CurrentContinuationException();
			}
		}
		public MalleableActor[] mergeRedistributeData(MalleableActor[] workers, int[] desiredWorkerData, MalleableActor[] workersToMerge) {
			Token workerData = new Token("workerData");
			{
				Token token_2_0 = new Token();
				// join block
				token_2_0.setJoinDirector();
				for (int i = 0; i<workers.length; i++){
					{
						// workers[i]<-getDataSize()
						{
							Object _arguments[] = {  };
							Message message = new Message( self, workers[i], "getDataSize", _arguments, null, token_2_0 );
							__messages.add( message );
						}
					}
				}
				addJoinToken(token_2_0);
				// token workerData = identity(token)
				{
					Object _arguments[] = { token_2_0 };
					Message message = new Message( self, self, "identity", _arguments, token_2_0, workerData );
					__messages.add( message );
				}
			}
			Token mergeData = new Token("mergeData");
			{
				Token token_2_0 = new Token();
				// join block
				token_2_0.setJoinDirector();
				for (int i = 0; i<workersToMerge.length; i++){
					{
						// workersToMerge[i]<-getDataSize()
						{
							Object _arguments[] = {  };
							Message message = new Message( self, workersToMerge[i], "getDataSize", _arguments, null, token_2_0 );
							__messages.add( message );
						}
					}
				}
				addJoinToken(token_2_0);
				// token mergeData = identity(token)
				{
					Object _arguments[] = { token_2_0 };
					Message message = new Message( self, self, "identity", _arguments, token_2_0, mergeData );
					__messages.add( message );
				}
			}
			{
				// mrdHelper(workerData, mergeData, workers, desiredWorkerData, workersToMerge)
				{
					Object _arguments[] = { workerData, mergeData, workers, desiredWorkerData, workersToMerge };
					Message message = new Message( self, self, "mrdHelper", _arguments, null, currentMessage.getContinuationToken() );
					__messages.add( message );
				}
				throw new CurrentContinuationException();
			}
		}
		public Object identity(Object o) {
			return o;
		}
		public MalleableActor[] mrdHelper(Object[] wd, Object[] md, MalleableActor[] workers, int[] desiredWorkerData, MalleableActor[] workersToMerge) {
			int[] workerData = new int[wd.length];
			for (int i = 0; i<wd.length; i++)workerData[i] = (int)((Long)wd[i]).longValue();
			int[] mergeData = new int[md.length];
			for (int i = 0; i<md.length; i++)mergeData[i] = (int)((Long)md[i]).longValue();
			int currentWorker = 0;
			int currentMerge = 0;
			System.err.println("Performing Merge:");
			System.err.println("\tnumber workers: "+workers.length);
			System.err.println("\tnumber workersToMerge: "+workersToMerge.length);
			System.err.println();
			{
				Token token_2_0 = new Token();
				// join block
				token_2_0.setJoinDirector();
				while (currentWorker<workers.length) {
					int dataToSend = desiredWorkerData[currentWorker]-workerData[currentWorker];
					System.err.println("\tworkerData["+currentWorker+"] = "+workerData[currentWorker]);
					System.err.println("\tdesiredWorkerData["+currentWorker+"] = "+desiredWorkerData[currentWorker]);
					System.err.println("\tcurrent worker["+currentWorker+"] sending "+dataToSend+" points.");
					while (dataToSend>0) {
						int toSend = Math.min(mergeData[currentMerge], dataToSend);
						System.err.println("\t\tmergeData["+currentMerge+"] = "+mergeData[currentMerge]);
						System.err.println("\t\tsending "+toSend+" to current target["+currentMerge+"].");
						{
							Token token_5_0 = new Token();
							// workersToMerge[currentMerge]<-getData(new Integer(toSend))
							{
								Object _arguments[] = { new Integer(toSend) };
								Message message = new Message( self, workersToMerge[currentMerge], "getData", _arguments, null, token_5_0 );
								__messages.add( message );
							}
							// workers[currentWorker]<-recieveData(token)
							{
								Object _arguments[] = { token_5_0 };
								Message message = new Message( self, workers[currentWorker], "recieveData", _arguments, token_5_0, token_2_0 );
								__messages.add( message );
							}
						}
						mergeData[currentMerge] -= toSend;
						if (mergeData[currentMerge]==0) {currentMerge++;
}						dataToSend -= toSend;
					}
					currentWorker++;
				}
				addJoinToken(token_2_0);
				// identity(workers)
				{
					Object _arguments[] = { workers };
					Message message = new Message( self, self, "identity", _arguments, token_2_0, currentMessage.getContinuationToken() );
					__messages.add( message );
				}
				throw new CurrentContinuationException();
			}
		}
	}
}