package gmle.salsa.physics;

import java.util.*;
import com.imsl.math.*;
import com.mindprod.ledatastream.*;
import java.io.*;

public class ComplexStream {
	private LERandomAccessFile myFile;
	private Complex current;
	private long markPos;
	private long rememberPos;
	private long startPos;


	public String toString() {
		return myFile.toString() + ", " + rememberPos;
	}

	public ComplexStream(String filename) throws FileNotFoundException, IOException {
		myFile=new LERandomAccessFile(filename, "r");
		rememberPos=myFile.getFilePointer();
	}

	public void next() throws IOException, EOFException {
		double re=myFile.readDouble();
		double im=myFile.readDouble();
		current = new Complex(re,im);
	}

	public Complex get() {
		return current;
	}
	
	public void setMark() throws IOException {
		markPos=myFile.getFilePointer();
	}
	
	public void restoreMark() throws IOException {
		myFile.seek(markPos);
	}

	public void setStartMark() throws IOException {
		startPos=myFile.getFilePointer();
	}
	
	public void restoreStartMark() throws IOException {
		myFile.seek(startPos);
	}

	public void restart() throws IOException {
		myFile.seek(rememberPos);
	}
}
