package gmle.salsa.sum_of_squares;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import gmle.salsa.framework.GradientDescent;
import gmle.salsa.framework.GeneticSearch;
import gmle.salsa.framework.Simplex;
import gmle.salsa.framework.Evaluator;

public class SumOfSquares extends UniversalActor implements Evaluator {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getReception().getLocation() + System.getProperty("identifier"));
		}
		SumOfSquares instance = (SumOfSquares)new SumOfSquares(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new SumOfSquares(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return SumOfSquares.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new SumOfSquares(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return SumOfSquares.getReferenceByLocation(new UAL(ual)); }
	public SumOfSquares(boolean o, UAN __uan)	{ super(o,__uan); }
	public SumOfSquares(boolean o, UAL __ual)	{ super(o,__ual); }

	public SumOfSquares(UAN __uan)	{ this(__uan, null); }
	public SumOfSquares(UAL __ual)	{ this(null, __ual); }
	public SumOfSquares()		{ this(null, null);  }
	public SumOfSquares(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getReception().getLocation())) {
			createRemotely(__uan, __ual, "gmle.salsa.sum_of_squares.SumOfSquares");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public SumOfSquares self;
		public SumOfSquares.State  _this = this;
		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "gmle.salsa.sum_of_squares.SumOfSquares$State" );
			addMethodsForClasses();
		}

		public void updateSelf(ActorReference actorReference) {
			self = (SumOfSquares)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
			super.updateSelf(self);
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Throwable exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			String exceptionMessage = "Message processing exception:\n";
			if (message.getSource() != null) {
				exceptionMessage += "\tSent by: " + message.getSource().toString() + "\n";
			} else exceptionMessage += "\tSent by: unknown\n";
			exceptionMessage += "\tReceived by actor: " + toString() + "\n";
			exceptionMessage += "\tMessage: " + message.toString() + "\n";
			if (exception == null) {
				if (matches == null) {
					exceptionMessage += "\tNo methods with the same name found.\n";
				System.err.println(exceptionMessage);
					return;
				}
				exceptionMessage += "\tDid not match any of the following: \n";
				for (int i = 0; i < matches.length; i++) {
					exceptionMessage += "\t\tMethod: " + matches[i].getName() + "( ";
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						exceptionMessage += parTypes[j].getName() + " ";
					}
					exceptionMessage += ")\n";
				}
				System.err.println(exceptionMessage);
				return;
			} else {
				exceptionMessage += "\tThrew exception: " + exception + "\n";
				System.err.println(exceptionMessage);
				exception.printStackTrace();
			}
		}

		int parameter_length = 10;
		double[] constants;
		int local_length, min, max;
		public void init_data(int rank, int max_rank) {
			min = (int)(parameter_length*(((double)rank)/((double)max_rank)));
			max = (int)(parameter_length*(((double)(rank+1.0))/((double)max_rank)));
			local_length = max-min;
			constants = new double[local_length];
			for (int i = 0; i<local_length; i++){
				constants[i] = Math.random()*50.0;
			}
		}
		public double[] evaluate(double[] parameters) {
			double[] sum = new double[1];
			sum[0] = 0;
			for (int i = 0; i<local_length; i++){
				sum[0] += constants[i]*parameters[min+i]*parameters[min+i];
			}
			return sum;
		}
		public double combine(double[][] values) {
			double sum = 0.0;
			for (int i = 0; i<values.length; i++){
				sum += values[i][0];
			}
			return sum;
		}
		public void printUsage() {
			System.err.println("Error: invalid arguments.");
			System.err.println("\tusage: java gmle.salsa.sum_of_squares.SumOfSquares <search method> [theaters_file]");
			System.err.println("\tsearch methods:");
			System.err.println("\t\tgd\t- gradient descent");
			System.err.println("\t\tcgd\t- conjugate gradient descent");
			System.err.println("\t\thcgd\t- hessian conjugate gradient descent");
			System.err.println("\t\tgs\t- genetic search");
			System.err.println("\t\tsimplex\t- simplex");
			System.exit(0);
		}
		public void act(String[] arguments) {
			if (arguments.length!=1&&arguments.length!=2) {
				this.printUsage();
			}
			else {
				String theaters_file = null;
				if (arguments.length==2) theaters_file = arguments[1];
				if (arguments[0].equals("cgd")||arguments[0].equals("gd")||arguments[0].equals("hcgd")) {
					double[] initial_parameters = new double[parameter_length];
					double[] step_sizes = new double[parameter_length];
					for (int i = 0; i<parameter_length; i++){
						initial_parameters[i] = (Math.random()*10)-5.0;
						step_sizes[i] = 0.001;
					}
					GradientDescent gradient_descent = ((GradientDescent)new GradientDescent().construct());
					Token init_token = new Token( "init_token", null );
					if (theaters_file==null) {
						{
							// init_token = gradient_descent<-init_data("gmle.salsa.sum_of_squares.SumOfSquares", new Integer(4))
							Token init_token_next = new Token("<-_next");
							{
								Object _arguments[] = { "gmle.salsa.sum_of_squares.SumOfSquares", new Integer(4) };
								Message __message = new Message( self, gradient_descent, "init_data", _arguments, null, init_token_next );
								__messages.add( __message );
							}
							init_token = init_token_next;
						}
					}
					else {
						{
							// init_token = gradient_descent<-init_data("gmle.salsa.sum_of_squares.SumOfSquares", theaters_file)
							Token init_token_next = new Token("<-_next");
							{
								Object _arguments[] = { "gmle.salsa.sum_of_squares.SumOfSquares", theaters_file };
								Message __message = new Message( self, gradient_descent, "init_data", _arguments, null, init_token_next );
								__messages.add( __message );
							}
							init_token = init_token_next;
						}
					}
					{
						// init_token = gradient_descent<-set_evaluation_output("gd_evaluations")
						Token init_token_next = new Token("<-_next");
						{
							Object _arguments[] = { "gd_evaluations" };
							Message __message = new Message( self, gradient_descent, "set_evaluation_output", _arguments, null, init_token_next );
							__messages.add( __message );
						}
						init_token = init_token_next;
					}
					if (arguments[0].equals("gd")) {
						{
							// gradient_descent<-gradient_descent(initial_parameters, step_sizes)
							{
								Object _arguments[] = { initial_parameters, step_sizes };
								Message __message = new Message( self, gradient_descent, "gradient_descent", _arguments, null, null );
								Object[] _propertyInfo = { init_token };
								__message.setProperty( "waitfor", _propertyInfo );
								__messages.add( __message );
							}
						}
					}
					else if (arguments[0].equals("cgd")) {
						{
							// gradient_descent<-conjugate_gradient_descent(initial_parameters, step_sizes)
							{
								Object _arguments[] = { initial_parameters, step_sizes };
								Message __message = new Message( self, gradient_descent, "conjugate_gradient_descent", _arguments, null, null );
								Object[] _propertyInfo = { init_token };
								__message.setProperty( "waitfor", _propertyInfo );
								__messages.add( __message );
							}
						}
					}
					else if (arguments[0].equals("hcgd")) {
						{
							// gradient_descent<-hessian_conjugate_gradient_descent(initial_parameters, step_sizes)
							{
								Object _arguments[] = { initial_parameters, step_sizes };
								Message __message = new Message( self, gradient_descent, "hessian_conjugate_gradient_descent", _arguments, null, null );
								Object[] _propertyInfo = { init_token };
								__message.setProperty( "waitfor", _propertyInfo );
								__messages.add( __message );
							}
						}
					}
				}
				else if (arguments[0].equals("simplex")) {
					double[][] simplex_parameters = new double[parameter_length+1][parameter_length];
					for (int i = 0; i<simplex_parameters.length; i++){
						for (int j = 0; j<simplex_parameters[i].length; j++){
							if (i==j) simplex_parameters[i][j] = 10.0*Math.random();
							else simplex_parameters[i][j] = -10.0*Math.random();
						}
					}
					Simplex simplex = ((Simplex)new Simplex().construct());
					Token init_token = new Token( "init_token", null );
					if (theaters_file==null) {
						{
							// init_token = simplex<-init_data("gmle.salsa.sum_of_squares.SumOfSquares", new Integer(4))
							Token init_token_next = new Token("<-_next");
							{
								Object _arguments[] = { "gmle.salsa.sum_of_squares.SumOfSquares", new Integer(4) };
								Message __message = new Message( self, simplex, "init_data", _arguments, null, init_token_next );
								__messages.add( __message );
							}
							init_token = init_token_next;
						}
					}
					else {
						{
							// init_token = simplex<-init_data("gmle.salsa.sum_of_squares.SumOfSquares", theaters_file)
							Token init_token_next = new Token("<-_next");
							{
								Object _arguments[] = { "gmle.salsa.sum_of_squares.SumOfSquares", theaters_file };
								Message __message = new Message( self, simplex, "init_data", _arguments, null, init_token_next );
								__messages.add( __message );
							}
							init_token = init_token_next;
						}
					}
					{
						Token token_4_0 = new Token();
						// simplex<-set_evaluation_output("simplex_evaluations")
						{
							Object _arguments[] = { "simplex_evaluations" };
							Message __message = new Message( self, simplex, "set_evaluation_output", _arguments, null, token_4_0 );
							Object[] _propertyInfo = { init_token };
							__message.setProperty( "waitfor", _propertyInfo );
							__messages.add( __message );
						}
						// simplex<-simplex(simplex_parameters)
						{
							Object _arguments[] = { simplex_parameters };
							Message __message = new Message( self, simplex, "simplex", _arguments, token_4_0, null );
							__messages.add( __message );
						}
					}
				}
				else if (arguments[0].equals("gs")) {
					double[] parameter_min = new double[parameter_length];
					double[] parameter_max = new double[parameter_length];
					for (int i = 0; i<parameter_length; i++){
						parameter_min[i] = -5.0;
						parameter_max[i] = 5.0;
					}
					GeneticSearch genetic_search = ((GeneticSearch)new GeneticSearch().construct());
					Token init_token = new Token( "init_token", null );
					if (theaters_file==null) {
						{
							// init_token = genetic_search<-init_data("gmle.salsa.sum_of_squares.SumOfSquares", new Integer(4))
							Token init_token_next = new Token("<-_next");
							{
								Object _arguments[] = { "gmle.salsa.sum_of_squares.SumOfSquares", new Integer(4) };
								Message __message = new Message( self, genetic_search, "init_data", _arguments, null, init_token_next );
								__messages.add( __message );
							}
							init_token = init_token_next;
						}
					}
					else {
						{
							// init_token = genetic_search<-init_data("gmle.salsa.sum_of_squares.SumOfSquares", theaters_file)
							Token init_token_next = new Token("<-_next");
							{
								Object _arguments[] = { "gmle.salsa.sum_of_squares.SumOfSquares", theaters_file };
								Message __message = new Message( self, genetic_search, "init_data", _arguments, null, init_token_next );
								__messages.add( __message );
							}
							init_token = init_token_next;
						}
					}
					{
						Token token_4_0 = new Token();
						// genetic_search<-set_evaluation_output("genetic_evaluations")
						{
							Object _arguments[] = { "genetic_evaluations" };
							Message __message = new Message( self, genetic_search, "set_evaluation_output", _arguments, null, token_4_0 );
							Object[] _propertyInfo = { init_token };
							__message.setProperty( "waitfor", _propertyInfo );
							__messages.add( __message );
						}
						// genetic_search<-genetic_search(parameter_min, parameter_max)
						{
							Object _arguments[] = { parameter_min, parameter_max };
							Message __message = new Message( self, genetic_search, "genetic_search", _arguments, token_4_0, null );
							__messages.add( __message );
						}
					}
				}
				else {
					this.printUsage();
				}
			}
		}
	}
}